Debian Bug report logs - #685625
[kfreebsd] libgeom: may cause segfault of grub-probe

version graph

Package: libgeom1; Maintainer for libgeom1 is GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>; Source for libgeom1 is src:freebsd-libs.

Reported by: Stig Sandbeck Mathisen <ssm@debian.org>

Date: Wed, 22 Aug 2012 17:57:01 UTC

Severity: grave

Tags: patch

Found in version freebsd-libs/9.0+ds1-3

Fixed in versions freebsd-libs/9.0+ds1-2, freebsd-libs/9.0+ds1-4

Done: Christoph Egger <christoph@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#685625; Package kfreebsd-image-9.0-2-amd64. (Wed, 22 Aug 2012 17:57:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Stig Sandbeck Mathisen <ssm@debian.org>:
New Bug report received and forwarded. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Wed, 22 Aug 2012 17:57:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Stig Sandbeck Mathisen <ssm@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: kfreebsd-image-9.0-2-amd64: segfaults when upgrading
Date: Wed, 22 Aug 2012 17:43:50 +0000
Package: kfreebsd-image-9.0-2-amd64
Version: 9.0-5
Severity: important

Dear Maintainer,

When using "apt-get upgrade" to get the latest version of
kfreebsd-image-9.0-2-amd64, the package segfaults in the "configure"
stage.

,----
| # dpkg --configure kfreebsd-image-9.0-2-amd64
| Setting up kfreebsd-image-9.0-2-amd64 (9.0-5) ...
| run-parts: executing /etc/kernel/postinst.d/apt-dater-host_reboot 9.0-2-amd64 /boot/kfreebsd-9.0-2-amd64.gz
| run-parts: executing /etc/kernel/postinst.d/zz-update-grub 9.0-2-amd64 /boot/kfreebsd-9.0-2-amd64.gz
| Segmentation fault
| Segmentation fault
| Generating grub.cfg ...
| Found kernel of FreeBSD: /boot/kfreebsd-9.0-2-amd64.gz
| Found kernel module directory: /lib/modules/9.0-2-amd64
| Segmentation fault
| Segmentation fault
| Segmentation fault
| ls: cannot access /lib/modules/9.0-2-amd64/unknown.ko: No such file or directory
| run-parts: /etc/kernel/postinst.d/zz-update-grub exited with return code 2
| dpkg: error processing kfreebsd-image-9.0-2-amd64 (--configure):
|  subprocess installed post-installation script returned error exit status 1
| Errors were encountered while processing:
|  kfreebsd-image-9.0-2-amd64
`----

Not sure if I dare reboot, but will assist with debugging if needed.

Thanks

-- System Information:
Debian Release: wheezy/sid
  APT prefers testing
  APT policy: (500, 'testing')
Architecture: kfreebsd-amd64 (x86_64)

Kernel: kFreeBSD 9.0-1-amd64
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages kfreebsd-image-9.0-2-amd64 depends on:
ii  devd           9.0+ds1-7
ii  freebsd-utils  9.0+ds1-7
ii  kbdcontrol     9.0+ds1-7
ii  kldutils       9.0+ds1-7

kfreebsd-image-9.0-2-amd64 recommends no packages.

kfreebsd-image-9.0-2-amd64 suggests no packages.

-- no debconf information



Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#685625; Package kfreebsd-image-9.0-2-amd64. (Wed, 22 Aug 2012 22:39:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steven Chamberlain <steven@pyro.eu.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Wed, 22 Aug 2012 22:39:05 GMT) Full text and rfc822 format available.

Message #10 received at 685625@bugs.debian.org (full text, mbox):

From: Steven Chamberlain <steven@pyro.eu.org>
To: Stig Sandbeck Mathisen <ssm@debian.org>, 685625@bugs.debian.org
Cc: "debian-bsd@lists.debian.org" <debian-bsd@lists.debian.org>
Subject: Re: Bug#685625: kfreebsd-image-9.0-2-amd64: segfaults when upgrading
Date: Wed, 22 Aug 2012 23:37:05 +0100
Hi!

One of my own kfreebsd-amd64 systems just upgraded okay.

It seems that something called by the grub-mkconfig shellscript was
segfaulting.  Could you please check your dmesg or kernel log as that
should say which executable it was?

Thanks!

Regards,
-- 
Steven Chamberlain
steven@pyro.eu.org



Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#685625; Package kfreebsd-image-9.0-2-amd64. (Wed, 22 Aug 2012 22:45:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steven Chamberlain <steven@pyro.eu.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Wed, 22 Aug 2012 22:45:05 GMT) Full text and rfc822 format available.

Message #15 received at 685625@bugs.debian.org (full text, mbox):

From: Steven Chamberlain <steven@pyro.eu.org>
To: Stig Sandbeck Mathisen <ssm@debian.org>, 685625@bugs.debian.org
Cc: "debian-bsd@lists.debian.org" <debian-bsd@lists.debian.org>
Subject: Re: Bug#685625: kfreebsd-image-9.0-2-amd64: segfaults when upgrading
Date: Wed, 22 Aug 2012 23:44:39 +0100
Oh, and you would probably get more useful info by running:

sh -x $(which grub-mkconfig)

That shouldn't change your GRUB config either, as it will just print it
to standard output if you don't use the -o flag as update-grub2 does.


I would guess that when this failure happened, it wouldn't have replaced
your GRUB config yet, so I would *hope* your system is still bootable
(assuming the old kernel image is still there).

Regards,
-- 
Steven Chamberlain
steven@pyro.eu.org



Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#685625; Package kfreebsd-image-9.0-2-amd64. (Thu, 23 Aug 2012 07:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Stig Sandbeck Mathisen <ssm@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Thu, 23 Aug 2012 07:45:03 GMT) Full text and rfc822 format available.

Message #20 received at 685625@bugs.debian.org (full text, mbox):

From: Stig Sandbeck Mathisen <ssm@debian.org>
To: Steven Chamberlain <steven@pyro.eu.org>
Cc: Stig Sandbeck Mathisen <ssm@debian.org>, 685625@bugs.debian.org, "debian-bsd\@lists.debian.org" <debian-bsd@lists.debian.org>
Subject: Re: Bug#685625: kfreebsd-image-9.0-2-amd64: segfaults when upgrading
Date: Thu, 23 Aug 2012 09:43:35 +0200
Steven Chamberlain <steven@pyro.eu.org> writes:

> Oh, and you would probably get more useful info by running:
>
> sh -x $(which grub-mkconfig)

Useful. Attached at the end.

> That shouldn't change your GRUB config either, as it will just print
> it to standard output if you don't use the -o flag as update-grub2
> does.

On inspection, the /boot/grub/grub.cfg file has not been replaced. I was
more worried about the files from the kernel package, though.

> I would guess that when this failure happened, it wouldn't have
> replaced your GRUB config yet, so I would *hope* your system is still
> bootable (assuming the old kernel image is still there).

The /boot/kfreebsd-9.0-2-amd64.gz is dated Jul 30, I would guess that to
be the previous version. Feel safer now. :)


,----[ output from: sh -x $(which grub-mkconfig) ]
| root@discordia:/var/log# sh -x $(which grub-mkconfig)
| + set -e
| + transform=s,x,x,
| + prefix=/usr
| + exec_prefix=/usr
| + datarootdir=/usr/share
| + prefix=/usr
| + exec_prefix=/usr
| + sbindir=/usr/sbin
| + bindir=/usr/bin
| + sysconfdir=/etc
| + PACKAGE_NAME=GRUB
| + PACKAGE_VERSION=1.99-22.1
| + host_os=kfreebsd-gnu
| + datadir=/usr/share
| + echo grub
| + sed s,x,x,
| + pkgdatadir=/usr/share/grub
| + grub_cfg=
| + grub_mkconfig_dir=/etc/grub.d
| + basename /usr/sbin/grub-mkconfig
| + self=grub-mkconfig
| + echo grub-mkdevicemap
| + sed s,x,x,
| + grub_mkdevicemap=/usr/sbin/grub-mkdevicemap
| + echo grub-probe
| + sed s,x,x,
| + grub_probe=/usr/sbin/grub-probe
| + echo grub-script-check
| + sed s,x,x,
| + grub_script_check=/usr/bin/grub-script-check
| + echo /boot/grub
| + sed s,//*,/,g
| + GRUB_PREFIX=/boot/grub
| + test 0 -gt 0
| + . /usr/share/grub/grub-mkconfig_lib
| + transform=s,x,x,
| + prefix=/usr
| + exec_prefix=/usr
| + datarootdir=/usr/share
| + datadir=/usr/share
| + bindir=/usr/bin
| + sbindir=/usr/sbin
| + echo grub
| + sed s,x,x,
| + pkgdatadir=/usr/share/grub
| + test x/usr/sbin/grub-probe = x
| + test x = x
| + echo grub-mkrelpath
| + sed s,x,x,
| + grub_mkrelpath=/usr/bin/grub-mkrelpath
| + which gettext
| + 
| + gettext=gettext
| + [ x = x ]
| + id -u
| + EUID=0
| + [ 0 != 0 ]
| + set /usr/sbin/grub-mkdevicemap dummy
| + test -f /usr/sbin/grub-mkdevicemap
| + :
| + set /usr/sbin/grub-probe dummy
| + test -f /usr/sbin/grub-probe
| + :
| + mkdir -p /boot/grub
| + test -e /boot/grub/device.map
| + :
| + /usr/sbin/grub-probe --target=device /
| + GRUB_DEVICE=/dev/ada1s1
| + /usr/sbin/grub-probe --device /dev/ada1s1 --target=fs_uuid
| Segmentation fault
| + GRUB_DEVICE_UUID=
| + true
| + /usr/sbin/grub-probe --target=device /boot
| + GRUB_DEVICE_BOOT=/dev/ada1s1
| + /usr/sbin/grub-probe --device /dev/ada1s1 --target=fs_uuid
| Segmentation fault
| + GRUB_DEVICE_BOOT_UUID=
| + true
| + /usr/sbin/grub-probe --device /dev/ada1s1 --target=fs
| + echo unknown
| + GRUB_FS=unknown
| + test -f /etc/default/grub
| + . /etc/default/grub
| + GRUB_DEFAULT=0
| + GRUB_TIMEOUT=5
| + lsb_release -i -s
| + GRUB_DISTRIBUTOR=Debian
| + GRUB_CMDLINE_LINUX_DEFAULT=quiet
| + GRUB_CMDLINE_LINUX=
| + [ x != x ]
| + termoutdefault=0
| + [ x = x ]
| + GRUB_TERMINAL_OUTPUT=gfxterm
| + termoutdefault=1
| + [ xgfxterm = xgfxterm ]
| + [ -n  ]
| + path=/usr/share/grub/unicode.pf2
| + is_path_readable_by_grub /usr/share/grub/unicode.pf2
| + path=/usr/share/grub/unicode.pf2
| + test -e /usr/share/grub/unicode.pf2
| + :
| + /usr/sbin/grub-probe -t fs /usr/share/grub/unicode.pf2
| + return 1
| + continue
| + path=/usr/share/grub/unifont.pf2
| + is_path_readable_by_grub /usr/share/grub/unifont.pf2
| + path=/usr/share/grub/unifont.pf2
| + test -e /usr/share/grub/unifont.pf2
| + return 1
| + continue
| + path=/usr/share/grub/ascii.pf2
| + is_path_readable_by_grub /usr/share/grub/ascii.pf2
| + path=/usr/share/grub/ascii.pf2
| + test -e /usr/share/grub/ascii.pf2
| + :
| + /usr/sbin/grub-probe -t fs /usr/share/grub/ascii.pf2
| + return 1
| + continue
| + path=/boot/grub/unicode.pf2
| + is_path_readable_by_grub /boot/grub/unicode.pf2
| + path=/boot/grub/unicode.pf2
| + test -e /boot/grub/unicode.pf2
| + return 1
| + continue
| + path=/boot/grub/unifont.pf2
| + is_path_readable_by_grub /boot/grub/unifont.pf2
| + path=/boot/grub/unifont.pf2
| + test -e /boot/grub/unifont.pf2
| + return 1
| + continue
| + path=/boot/grub/ascii.pf2
| + is_path_readable_by_grub /boot/grub/ascii.pf2
| + path=/boot/grub/ascii.pf2
| + test -e /boot/grub/ascii.pf2
| + return 1
| + continue
| + path=/usr/share/grub/unicode.pf2
| + is_path_readable_by_grub /usr/share/grub/unicode.pf2
| + path=/usr/share/grub/unicode.pf2
| + test -e /usr/share/grub/unicode.pf2
| + :
| + /usr/sbin/grub-probe -t fs /usr/share/grub/unicode.pf2
| + return 1
| + continue
| + path=/usr/share/grub/unifont.pf2
| + is_path_readable_by_grub /usr/share/grub/unifont.pf2
| + path=/usr/share/grub/unifont.pf2
| + test -e /usr/share/grub/unifont.pf2
| + return 1
| + continue
| + path=/usr/share/grub/ascii.pf2
| + is_path_readable_by_grub /usr/share/grub/ascii.pf2
| + path=/usr/share/grub/ascii.pf2
| + test -e /usr/share/grub/ascii.pf2
| + :
| + /usr/sbin/grub-probe -t fs /usr/share/grub/ascii.pf2
| + return 1
| + continue
| + [ -z  ]
| + [ x1 != x1 ]
| + GRUB_TERMINAL_OUTPUT=
| + export GRUB_DEVICE GRUB_DEVICE_UUID GRUB_DEVICE_BOOT GRUB_DEVICE_BOOT_UUID GRUB_FS GRUB_FONT_PATH GRUB_PRELOAD_MODULES GRUB_PREFIX
| + export GRUB_DEFAULT GRUB_HIDDEN_TIMEOUT GRUB_HIDDEN_TIMEOUT_QUIET GRUB_TIMEOUT GRUB_DEFAULT_BUTTON GRUB_HIDDEN_TIMEOUT_BUTTON GRUB_TIMEOUT_BUTTON GRUB_BUTTON_CMOS_ADDRESS GRUB_BUTTON_CMOS_CLEAN GRUB_DISTRIBUTOR GRUB_CMDLINE_LINUX GRUB_CMDLINE_LINUX_DEFAULT GRUB_CMDLINE_XEN GRUB_CMDLINE_XEN_DEFAULT GRUB_CMDLINE_LINUX_XEN_REPLACE GRUB_CMDLINE_LINUX_XEN_REPLACE_DEFAULT GRUB_CMDLINE_NETBSD GRUB_CMDLINE_NETBSD_DEFAULT GRUB_CMDLINE_GNUMACH GRUB_TERMINAL_INPUT GRUB_TERMINAL_OUTPUT GRUB_SERIAL_COMMAND GRUB_DISABLE_LINUX_UUID GRUB_DISABLE_RECOVERY GRUB_VIDEO_BACKEND GRUB_GFXMODE GRUB_BACKGROUND GRUB_THEME GRUB_GFXPAYLOAD_LINUX GRUB_DISABLE_OS_PROBER GRUB_INIT_TUNE GRUB_SAVEDEFAULT GRUB_BADRAM
| + test x != x
| + echo Generating grub.cfg ...
| Generating grub.cfg ...
| + cat
| #
| # DO NOT EDIT THIS FILE
| #
| # It is automatically generated by grub-mkconfig using templates
| # from /etc/grub.d and settings from /etc/default/grub
| #
| + grub_file_is_not_garbage /etc/grub.d/00_header
| + test -f /etc/grub.d/00_header
| + return 0
| + test -x /etc/grub.d/00_header
| + echo
| 
| + echo ### BEGIN /etc/grub.d/00_header ###
| ### BEGIN /etc/grub.d/00_header ###
| + /etc/grub.d/00_header
| if [ -s $prefix/grubenv ]; then
|   load_env
| fi
| set default="0"
| if [ "${prev_saved_entry}" ]; then
|   set saved_entry="${prev_saved_entry}"
|   save_env saved_entry
|   set prev_saved_entry=
|   save_env prev_saved_entry
|   set boot_once=true
| fi
| 
| function savedefault {
|   if [ -z "${boot_once}" ]; then
|     saved_entry="${chosen}"
|     save_env saved_entry
|   fi
| }
| 
| function load_video {
|   insmod vbe
|   insmod vga
|   insmod video_bochs
|   insmod video_cirrus
| }
| 
| set timeout=5
| + echo ### END /etc/grub.d/00_header ###
| ### END /etc/grub.d/00_header ###
| + grub_file_is_not_garbage /etc/grub.d/05_debian_theme
| + test -f /etc/grub.d/05_debian_theme
| + return 0
| + test -x /etc/grub.d/05_debian_theme
| + echo
| 
| + echo ### BEGIN /etc/grub.d/05_debian_theme ###
| ### BEGIN /etc/grub.d/05_debian_theme ###
| + /etc/grub.d/05_debian_theme
| set menu_color_normal=cyan/blue
| set menu_color_highlight=white/blue
| + echo ### END /etc/grub.d/05_debian_theme ###
| ### END /etc/grub.d/05_debian_theme ###
| + grub_file_is_not_garbage /etc/grub.d/10_kfreebsd
| + test -f /etc/grub.d/10_kfreebsd
| + return 0
| + test -x /etc/grub.d/10_kfreebsd
| + echo
| 
| + echo ### BEGIN /etc/grub.d/10_kfreebsd ###
| ### BEGIN /etc/grub.d/10_kfreebsd ###
| + /etc/grub.d/10_kfreebsd
| Found kernel of FreeBSD: /boot/kfreebsd-9.0-2-amd64.gz
| Found kernel module directory: /lib/modules/9.0-2-amd64
| menuentry 'Debian GNU/kFreeBSD, with kFreeBSD 9.0-2-amd64' --class debian --class gnu-kfreebsd --class gnu --class os {
| Segmentation fault
| 
| 	echo			'Loading kernel of FreeBSD 9.0-2-amd64 ...'
| 	kfreebsd		/root/@/boot/kfreebsd-9.0-2-amd64.gz 
| Segmentation fault
| Segmentation fault
| ls: cannot access /lib/modules/9.0-2-amd64/unknown.ko: No such file or directory
`----


,----[ output from: zpool status ]
| root@discordia:~# zpool status
|   pool: rpool
|  state: ONLINE
|  scan: scrub repaired 0 in 0h0m with 0 errors on Sun Aug  5 00:57:50 2012
| config:
| 
| 	NAME        STATE     READ WRITE CKSUM
| 	rpool       ONLINE       0     0     0
| 	  ada1s1    ONLINE       0     0     0
| 
| errors: No known data errors
| 
|   pool: tank
|  state: ONLINE
|  scan: scrub repaired 0 in 0h23m with 0 errors on Sun Aug  5 01:21:00 2012
| config:
| 
| 	NAME        STATE     READ WRITE CKSUM
| 	tank        ONLINE       0     0     0
| 	  -0        ONLINE       0     0     0
| 	    ada0    ONLINE       0     0     0
| 	    ada2    ONLINE       0     0     0
| 	    ada3    ONLINE       0     0     0
| 	    ada4    ONLINE       0     0     0
| 
| errors: No known data errors
`----


-- 
Stig Sandbeck Mathisen



Changed Bug title to 'grub-probe segfaults' from 'kfreebsd-image-9.0-2-amd64: segfaults when upgrading' Request was from Stig Sandbeck Mathisen <ssm@debian.org> to control@bugs.debian.org. (Thu, 23 Aug 2012 07:57:05 GMT) Full text and rfc822 format available.

Bug reassigned from package 'kfreebsd-image-9.0-2-amd64' to 'grub-common'. Request was from Stig Sandbeck Mathisen <ssm@debian.org> to control@bugs.debian.org. (Thu, 23 Aug 2012 07:57:07 GMT) Full text and rfc822 format available.

No longer marked as found in versions kfreebsd-9/9.0-5. Request was from Stig Sandbeck Mathisen <ssm@debian.org> to control@bugs.debian.org. (Thu, 23 Aug 2012 07:57:08 GMT) Full text and rfc822 format available.

Marked as found in versions grub2/1.99-22.1. Request was from Stig Sandbeck Mathisen <ssm@debian.org> to control@bugs.debian.org. (Thu, 23 Aug 2012 07:57:08 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#685625; Package grub-common. (Thu, 23 Aug 2012 08:15:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Stig Sandbeck Mathisen <ssm@debian.org>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Thu, 23 Aug 2012 08:15:04 GMT) Full text and rfc822 format available.

Message #33 received at 685625@bugs.debian.org (full text, mbox):

From: Stig Sandbeck Mathisen <ssm@debian.org>
To: Steven Chamberlain <steven@pyro.eu.org>
Cc: Stig Sandbeck Mathisen <ssm@debian.org>, 685625@bugs.debian.org
Subject: Re: Bug#685625: kfreebsd-image-9.0-2-amd64: segfaults when upgrading
Date: Thu, 23 Aug 2012 09:36:00 +0200
Steven Chamberlain <steven@pyro.eu.org> writes:

> Hi!
>
> One of my own kfreebsd-amd64 systems just upgraded okay.
>
> It seems that something called by the grub-mkconfig shellscript was
> segfaulting. Could you please check your dmesg or kernel log as that
> should say which executable it was?

That looks to be be grub-probe, from the "grub-common" package.

Aug 22 17:37:02 discordia kernel: pid 70072 (grub-probe), uid 0: exited on signal 11
Aug 22 17:37:04 discordia kernel: pid 70077 (grub-probe), uid 0: exited on signal 11
Aug 22 17:37:06 discordia kernel: pid 70079 (grub-probe), uid 0: exited on signal 11
Aug 22 17:37:09 discordia kernel: pid 70088 (grub-probe), uid 0: exited on signal 11
Aug 22 17:37:10 discordia kernel: pid 70091 (grub-probe), uid 0: exited on signal 11

I'll retitle and reassign the bug to the correct package.

Thanks for the quick response. :)

-- 
Stig Sandbeck Mathisen



Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#685625; Package grub-common. (Thu, 23 Aug 2012 11:12:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steven Chamberlain <steven@pyro.eu.org>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Thu, 23 Aug 2012 11:12:03 GMT) Full text and rfc822 format available.

Message #38 received at 685625@bugs.debian.org (full text, mbox):

From: Steven Chamberlain <steven@pyro.eu.org>
To: Stig Sandbeck Mathisen <ssm@debian.org>, 685625@bugs.debian.org
Cc: "debian-bsd@lists.debian.org" <debian-bsd@lists.debian.org>
Subject: Re: Bug#685625: kfreebsd-image-9.0-2-amd64: segfaults when upgrading
Date: Thu, 23 Aug 2012 12:07:49 +0100
Hi,

On 23/08/12 08:43, Stig Sandbeck Mathisen wrote:
> The /boot/kfreebsd-9.0-2-amd64.gz is dated Jul 30, I would guess that to
> be the previous version. Feel safer now. :)

Actually I think that is the kernel that was just (part-)installed.  The
old one would be kfreebsd-9.0-1-amd64.gz, I hope it is still in /boot


Hmmm also I know this is a different pool to your root/boot device
(ada1s1) but:

> | 	tank        ONLINE       0     0     0
> | 	  -0        ONLINE       0     0     0

It should say mirror-0 there?  I guess this might be triggering some bug
in the grub2 no_libzfs.patch which parses that output of zpool status.

What is the version of your installed zfsutils package?

And could you please get the full output of `uname -a` to be sure of the
exact package version of the running kernel.

Thank you for your feedback so far.

Regards,
-- 
Steven Chamberlain
steven@pyro.eu.org



Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#685625; Package grub-common. (Thu, 23 Aug 2012 11:57:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steven Chamberlain <steven@pyro.eu.org>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Thu, 23 Aug 2012 11:57:02 GMT) Full text and rfc822 format available.

Message #43 received at 685625@bugs.debian.org (full text, mbox):

From: Steven Chamberlain <steven@pyro.eu.org>
To: Stig Sandbeck Mathisen <ssm@debian.org>, 685625@bugs.debian.org
Cc: "debian-bsd@lists.debian.org" <debian-bsd@lists.debian.org>
Subject: Re: Bug#685625: kfreebsd-image-9.0-2-amd64: segfaults when upgrading
Date: Thu, 23 Aug 2012 12:55:27 +0100
Hello again Stig,

I still can't reproduce this with kfreebsd-amd64 that has root/boot on
ZFS and the same GRUB2 (1.99-22.1).  I even replaced my zpool executable
with something that gives identical output to yours.

I'd be grateful if you could please install the ktrace package and get a
syscall trace with:

# ktrace -di -- grub-probe --device /dev/ada1s1 --target=fs_uuid
# kdump -f ktrace.out | gzip > kdump.txt.gz

Or a GDB backtrace of course:

# gdb $(which grub-probe)
run --device /dev/ada1s1 --target=fs_uuid
<crashes>
bt full
quit

Thanks!
Regards,
-- 
Steven Chamberlain
steven@pyro.eu.org



Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#685625; Package grub-common. (Thu, 23 Aug 2012 13:03:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Stig Sandbeck Mathisen <ssm@debian.org>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Thu, 23 Aug 2012 13:03:03 GMT) Full text and rfc822 format available.

Message #48 received at 685625@bugs.debian.org (full text, mbox):

From: Stig Sandbeck Mathisen <ssm@debian.org>
To: Steven Chamberlain <steven@pyro.eu.org>
Cc: Stig Sandbeck Mathisen <ssm@debian.org>, 685625@bugs.debian.org, "debian-bsd\@lists.debian.org" <debian-bsd@lists.debian.org>
Subject: Re: Bug#685625: grub-probe segfaults
Date: Thu, 23 Aug 2012 14:59:00 +0200
[Message part 1 (text/plain, inline)]
Steven Chamberlain <steven@pyro.eu.org> writes:

> Hello again Stig,
>
> I still can't reproduce this with kfreebsd-amd64 that has root/boot on
> ZFS and the same GRUB2 (1.99-22.1). I even replaced my zpool
> executable with something that gives identical output to yours.
>
> I'd be grateful if you could please install the ktrace package and get
> a syscall trace with:
>
> # ktrace -di -- grub-probe --device /dev/ada1s1 --target=fs_uuid
> # kdump -f ktrace.out | gzip > kdump.txt.gz

Attached.

[kdump.txt.gz (application/octet-stream, attachment)]
[Message part 3 (text/plain, inline)]
> Or a GDB backtrace of course:
>
> # gdb $(which grub-probe)
> run --device /dev/ada1s1 --target=fs_uuid
> <crashes>
> bt full
> quit

Here is one of those, it does not look as helpful, though.

Would this look different if a grub-dbg package was available? (or grub
was not stripped?)

,----
| root@discordia:~# gdb $(which grub-probe)
| GNU gdb (GDB) 7.4.1-debian
| Copyright (C) 2012 Free Software Foundation, Inc.
| License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>
| This is free software: you are free to change and redistribute it.
| There is NO WARRANTY, to the extent permitted by law.  Type "show copying"
| and "show warranty" for details.
| This GDB was configured as "x86_64-kfreebsd-gnu".
| For bug reporting instructions, please see:
| <http://www.gnu.org/software/gdb/bugs/>...
| Reading symbols from /usr/sbin/grub-probe...(no debugging symbols found)...done.
| (gdb) run --device /dev/ada1s1 --target=fs_uuid
| Starting program: /usr/sbin/grub-probe --device /dev/ada1s1 --target=fs_uuid
| 
| Program received signal SIGSEGV, Segmentation fault.
| 0x0000000800ae8401 in strlen () from /lib/x86_64-kfreebsd-gnu/libc.so.0.1
| (gdb) bt full
| #0  0x0000000800ae8401 in strlen () from /lib/x86_64-kfreebsd-gnu/libc.so.0.1
| No symbol table info available.
| #1  0x000000080086c868 in geom_xml2tree () from /lib/libgeom.so.1
| No symbol table info available.
| #2  0x000000080086cae9 in geom_gettree () from /lib/libgeom.so.1
| No symbol table info available.
| #3  0x00000000004312fe in ?? ()
| No symbol table info available.
| #4  0x00000000004320b8 in ?? ()
| No symbol table info available.
| #5  0x000000000043211a in ?? ()
| No symbol table info available.
| #6  0x000000000043235e in ?? ()
| No symbol table info available.
| #7  0x00000000004310f9 in ?? ()
| No symbol table info available.
| #8  0x000000000043112e in ?? ()
| No symbol table info available.
| #9  0x000000000040218e in ?? ()
| No symbol table info available.
| #10 0x0000000000401ef2 in ?? ()
| No symbol table info available.
| #11 0x0000000800a8d349 in __libc_start_main () from /lib/x86_64-kfreebsd-gnu/libc.so.0.1
| No symbol table info available.
| #12 0x0000000000401fe8 in ?? ()
| No symbol table info available.
| #13 0x00007fffffffd668 in ?? ()
| No symbol table info available.
| #14 0x000000000000001c in ?? ()
| No symbol table info available.
| #15 0x0000000000000000 in ?? ()
| No symbol table info available.
| (gdb) quit
| A debugging session is active.
| 
| 	Inferior 1 [process 284] will be killed.
| 
| Quit anyway? (y or n) y
`----


Thanks. :)

-- 
Stig Sandbeck Mathisen <ssm@debian.org>

Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#685625; Package grub-common. (Thu, 23 Aug 2012 13:18:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steven Chamberlain <steven@pyro.eu.org>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Thu, 23 Aug 2012 13:18:03 GMT) Full text and rfc822 format available.

Message #53 received at 685625@bugs.debian.org (full text, mbox):

From: Steven Chamberlain <steven@pyro.eu.org>
To: Stig Sandbeck Mathisen <ssm@debian.org>
Cc: 685625@bugs.debian.org, "debian-bsd@lists.debian.org" <debian-bsd@lists.debian.org>
Subject: Re: Bug#685625: grub-probe segfaults
Date: Thu, 23 Aug 2012 14:14:50 +0100
Hi!

On 23/08/12 13:59, Stig Sandbeck Mathisen wrote:
> Would this look different if a grub-dbg package was available? (or grub
> was not stripped?)

> | (gdb) bt full
> | #0  0x0000000800ae8401 in strlen () from /lib/x86_64-kfreebsd-gnu/libc.so.0.1
> | No symbol table info available.
> | #1  0x000000080086c868 in geom_xml2tree () from /lib/libgeom.so.1
> | No symbol table info available.
> | #2  0x000000080086cae9 in geom_gettree () from /lib/libgeom.so.1
> | No symbol table info available.

There is useful info here already I think.  And the ktrace also agrees
we should now be looking at:

# sysctl kern.geom.confxml

The bug is probably in libgeom (freebsd-libs), and may have something to
do with changes to partitioning, or some disk that was attached.

Thanks,
Regards,
-- 
Steven Chamberlain
steven@pyro.eu.org



Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#685625; Package grub-common. (Thu, 23 Aug 2012 13:21:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Stig Sandbeck Mathisen <ssm@debian.org>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Thu, 23 Aug 2012 13:21:05 GMT) Full text and rfc822 format available.

Message #58 received at 685625@bugs.debian.org (full text, mbox):

From: Stig Sandbeck Mathisen <ssm@debian.org>
To: Steven Chamberlain <steven@pyro.eu.org>
Cc: Stig Sandbeck Mathisen <ssm@debian.org>, 685625@bugs.debian.org, "debian-bsd\@lists.debian.org" <debian-bsd@lists.debian.org>
Subject: Re: Bug#685625: kfreebsd-image-9.0-2-amd64: segfaults when upgrading
Date: Thu, 23 Aug 2012 14:50:38 +0200
Steven Chamberlain <steven@pyro.eu.org> writes:

> Hmmm also I know this is a different pool to your root/boot device
> (ada1s1) but:
>
>> | 	tank        ONLINE       0     0     0
>> | 	  -0        ONLINE       0     0     0
>
> It should say mirror-0 there?

"raidz1", in my case.

> I guess this might be triggering some bug in the grub2 no_libzfs.patch
> which parses that output of zpool status.

That looks like a display issue in "zpool status" on debian kfreebsd. I
haven't seen other output than "-0". "zpool iostat" shows it correctly.

Compare:

,----
| root@discordia:~# zpool iostat -v tank
|                capacity     operations    bandwidth
| pool        alloc   free   read  write   read  write
| ----------  -----  -----  -----  -----  -----  -----
| tank        6.05T  1.20T      1     16   105K  1.56M
|   raidz1    6.05T  1.20T      1     16   105K  1.56M
|     ada0        -      -      0      7  34.9K   533K
|     ada2        -      -      0      7  34.8K   533K
|     ada3        -      -      0      7  34.9K   533K
|     ada4        -      -      0      7  34.8K   533K
| ----------  -----  -----  -----  -----  -----  -----
`----

,----
| root@discordia:~# zpool status tank
|   pool: tank
|  state: ONLINE
|  scan: scrub repaired 0 in 0h23m with 0 errors on Sun Aug  5 01:21:00 2012
| config:
| 
| 	NAME        STATE     READ WRITE CKSUM
| 	tank        ONLINE       0     0     0
| 	  -0        ONLINE       0     0     0
| 	    ada0    ONLINE       0     0     0
| 	    ada2    ONLINE       0     0     0
| 	    ada3    ONLINE       0     0     0
| 	    ada4    ONLINE       0     0     0
| 
| errors: No known data errors
`----

A previous kernel image has been installed and updated correctly, with
this disk configuration.

,----
| Start-Date: 2012-07-11  20:07:29
| Commandline: apt-get -o APT::Status-Fd=4 -o APT::Keep-Fds::=5 -o APT::Keep-Fds::=6 -q -y --no-remove install kfreebsd-image-9-amd64
| Install: kfreebsd-image-9.0-1-amd64:kfreebsd-amd64 (9.0-4, automatic), kfreebsd-image-9-amd64:kfreebsd-amd64 (9.0-4)
| End-Date: 2012-07-11  20:07:30
`----

> What is the version of your installed zfsutils package?

zfsutils 9.0-3

(Installed during the same run as the "2012-07-11 20:07:29" kernel
update, but after the kernel image)

> And could you please get the full output of `uname -a` to be sure of
> the exact package version of the running kernel.

root@discordia:~# uname -a
GNU/kFreeBSD discordia 9.0-1-amd64 #0 Fri Jun 15 21:15:10 UTC 2012 x86_64 amd64 AMD Phenom(tm) II X4 905e Processor GNU/kFreeBSD

-- 
Stig Sandbeck Mathisen <ssm@debian.org>



Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#685625; Package grub-common. (Thu, 23 Aug 2012 13:27:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steven Chamberlain <steven@pyro.eu.org>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Thu, 23 Aug 2012 13:27:06 GMT) Full text and rfc822 format available.

Message #63 received at 685625@bugs.debian.org (full text, mbox):

From: Steven Chamberlain <steven@pyro.eu.org>
To: Stig Sandbeck Mathisen <ssm@debian.org>
Cc: 685625@bugs.debian.org, "debian-bsd@lists.debian.org" <debian-bsd@lists.debian.org>
Subject: Re: Bug#685625: grub-probe segfaults
Date: Thu, 23 Aug 2012 14:25:45 +0100
The XML dump can include disklabels of removable media.  There was a
problem once with its handling of special characters like < > & but our
kernels already have a patch applied for that (maybe it was insufficient?) :

http://svnweb.freebsd.org/base/release/9.0.0/sys/geom/geom_dump.c?view=log#rev205385

Please attach a gzipped (to preserve the character encoding) copy of the
`sysctl kern.geom.confxml` output if you wouldn't mind.

Thanks,
Regards,
-- 
Steven Chamberlain
steven@pyro.eu.org



Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#685625; Package grub-common. (Thu, 23 Aug 2012 15:12:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Stig Sandbeck Mathisen <ssm@debian.org>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Thu, 23 Aug 2012 15:12:03 GMT) Full text and rfc822 format available.

Message #68 received at 685625@bugs.debian.org (full text, mbox):

From: Stig Sandbeck Mathisen <ssm@debian.org>
To: Steven Chamberlain <steven@pyro.eu.org>
Cc: Stig Sandbeck Mathisen <ssm@debian.org>, 685625@bugs.debian.org, "debian-bsd\@lists.debian.org" <debian-bsd@lists.debian.org>
Subject: Re: Bug#685625: grub-probe segfaults
Date: Thu, 23 Aug 2012 17:07:41 +0200
[Message part 1 (text/plain, inline)]
Steven Chamberlain <steven@pyro.eu.org> writes:

> There is useful info here already I think. And the ktrace also agrees
> we should now be looking at:
>
> # sysctl kern.geom.confxml
>
> The bug is probably in libgeom (freebsd-libs), and may have something
> to do with changes to partitioning, or some disk that was attached.

There was an enclosure attached, at a time. The box has not been
rebooted since then.

Attached sysctl output:

[kern.geom.confxml.gz (application/octet-stream, attachment)]
[Message part 3 (text/plain, inline)]
…which tells me, among other things, that I really should not snapshot
my swap partition. :)

-- 
Stig Sandbeck Mathisen <ssm@debian.org>

Information forwarded to debian-bugs-dist@lists.debian.org, GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>:
Bug#685625; Package grub-common. (Thu, 23 Aug 2012 15:33:28 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steven Chamberlain <steven@pyro.eu.org>:
Extra info received and forwarded to list. Copy sent to GRUB Maintainers <pkg-grub-devel@lists.alioth.debian.org>. (Thu, 23 Aug 2012 15:33:28 GMT) Full text and rfc822 format available.

Message #73 received at 685625@bugs.debian.org (full text, mbox):

From: Steven Chamberlain <steven@pyro.eu.org>
To: Stig Sandbeck Mathisen <ssm@debian.org>
Cc: 685625@bugs.debian.org, "debian-bsd@lists.debian.org" <debian-bsd@lists.debian.org>
Subject: Re: Bug#685625: libgeom: segfaults on large kern.geom.confxml
Date: Thu, 23 Aug 2012 16:30:56 +0100
retitle 685625 libgeom: segfaults on large kern.geom.confxml
reassign 685625 src:freebsd-utils
affects 685625 grub-common
found 685625 9.0+ds1-7
user debian-bsd@lists.debian.org
usertags 685625 kfreebsd
thanks

Hi!

I'm reassigning this because GRUB can't really avoid this crash in libgeom.

I don't see anything else odd about the XML except for its size.  It
seems, then that 6510 snapshots makes the kern.geom.confxml larger than
libgeom can handle?  Though I didn't find any hard-coded buffer sizes.

Since ZFS is supposed to be the filesystem without limits etc. I still
think it's important to fix this.

Thank you very much for your help.

I suppose you could try now removing those accidental snapshots of swap
and see if it starts to work again.  If so, it might be interesting to
know the approximate size of the kern.geom.confxml output at which
grub-probe starts to work again.

BTW:  the script bundled in /etc/cron.daily/zfsutils has a nice
algorithm for creating + keeping up to 'n' snapshots, and deletes old
ones in a way that prefers to keep mostly the more recent ones, with an
exponential decay.  It's very neat.

Regards,
-- 
Steven Chamberlain
steven@pyro.eu.org



Changed Bug title to 'libgeom: segfaults on large kern.geom.confxml' from 'grub-probe segfaults' Request was from Steven Chamberlain <steven@pyro.eu.org> to control@bugs.debian.org. (Thu, 23 Aug 2012 15:33:32 GMT) Full text and rfc822 format available.

Bug reassigned from package 'grub-common' to 'src:freebsd-utils'. Request was from Steven Chamberlain <steven@pyro.eu.org> to control@bugs.debian.org. (Thu, 23 Aug 2012 15:33:33 GMT) Full text and rfc822 format available.

No longer marked as found in versions grub2/1.99-22.1. Request was from Steven Chamberlain <steven@pyro.eu.org> to control@bugs.debian.org. (Thu, 23 Aug 2012 15:33:33 GMT) Full text and rfc822 format available.

Added indication that 685625 affects grub-common Request was from Steven Chamberlain <steven@pyro.eu.org> to control@bugs.debian.org. (Thu, 23 Aug 2012 15:33:34 GMT) Full text and rfc822 format available.

Marked as found in versions freebsd-utils/9.0+ds1-7. Request was from Steven Chamberlain <steven@pyro.eu.org> to control@bugs.debian.org. (Thu, 23 Aug 2012 15:33:34 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#685625; Package src:freebsd-utils. (Thu, 23 Aug 2012 16:09:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Stig Sandbeck Mathisen <ssm@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Thu, 23 Aug 2012 16:09:03 GMT) Full text and rfc822 format available.

Message #88 received at 685625@bugs.debian.org (full text, mbox):

From: Stig Sandbeck Mathisen <ssm@debian.org>
To: Steven Chamberlain <steven@pyro.eu.org>
Cc: Stig Sandbeck Mathisen <ssm@debian.org>, 685625@bugs.debian.org, "debian-bsd\@lists.debian.org" <debian-bsd@lists.debian.org>
Subject: Re: Bug#685625: libgeom: segfaults on large kern.geom.confxml
Date: Thu, 23 Aug 2012 18:04:36 +0200
Steven Chamberlain <steven@pyro.eu.org> writes:

> I'm reassigning this because GRUB can't really avoid this crash in libgeom.
>
> I don't see anything else odd about the XML except for its size. It
> seems, then that 6510 snapshots makes the kern.geom.confxml larger
> than libgeom can handle? Though I didn't find any hard-coded buffer
> sizes.

Just noticed a funny thing: The zfs snapshot count on my box is much
lower than the list in kern.geom.confxml.

None of the zfs "filesystem" snapshots show up in kern.geom.confxml, but
all snapshots ever created of the "rpool/swap" zfs volume (not a
filesystem, but a "device") is there. Even those which has been deleted
by the zfs snapshot script. 

None of the zfs filesystems are present in kern.geom.confxml, either.

So kern.geom.confxml lists devices that do not exist. I suspect that
this may also be a source of confusion for libgeom.

I removed all the snapshots from the swap device, and some others, with
no effect on grub-probe.  Even when all snapshots are removed, they are
still present in kern.geom.confxml.

Thanks for your help so far. :)

-- 
Stig Sandbeck Mathisen <ssm@debian.org>



Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#685625; Package src:freebsd-utils. (Fri, 21 Dec 2012 18:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jeff Epler <jepler@unpythonic.net>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Fri, 21 Dec 2012 18:57:03 GMT) Full text and rfc822 format available.

Message #93 received at 685625@bugs.debian.org (full text, mbox):

From: Jeff Epler <jepler@unpythonic.net>
To: 685625@bugs.debian.org
Subject: implicit declaration of function ‘reallocf’
Date: Fri, 21 Dec 2012 12:45:08 -0600
It looks like this is the problem, and it exists repeatedly in
freebsd-libs-9.0+ds1-7

geom_getxml.c: In function ‘geom_getxml’:
geom_getxml.c:59:2: warning: implicit declaration of function ‘reallocf’ [-Wimplicit-function-declaration]
geom_getxml.c:59:2: warning: return makes pointer from integer without a cast [enabled by default]

On kfreebsd-amd64 systems, the consequence of this is that the top 32
bits of a pointer returned by reallocf are discarded.

In fact, adding this include appears to fix the specific crash in
grub-probe:
 #include <string.h>
+#include <bsd/stdlib.h>

Based on this information, I hope to be able to submit a patch soon.

Jeff



Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#685625; Package src:freebsd-utils. (Fri, 21 Dec 2012 19:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jeff Epler <jepler@unpythonic.net>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Fri, 21 Dec 2012 19:39:03 GMT) Full text and rfc822 format available.

Message #98 received at 685625@bugs.debian.org (full text, mbox):

From: Jeff Epler <jepler@unpythonic.net>
To: 685625@bugs.debian.org
Subject: [PATCH] Re: Bug#685625: implicit declaration of function ‘reallocf’
Date: Fri, 21 Dec 2012 13:36:36 -0600
[Message part 1 (text/plain, inline)]
Control: tags -1 + patch

I believe the attached patch fixes the problem; it does on my system.

Because the impact of this bug is the inability to install or update the
bootloader (including, potentially, during initial installation), I
believe the severity should be increased to critical.  However, I am not
modifying the priority myself as I'm not yet familiar with the culture
around changing bug severity, particularly when escalating it.


-- System Information:
Debian Release: wheezy/sid
  APT prefers testing
  APT policy: (500, 'testing'), (1, 'experimental')
Architecture: kfreebsd-amd64 (x86_64)

Kernel: kFreeBSD 9.0-2-amd64
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages libgeom1 depends on:
ii  libbsd0    0.4.2-1
ii  libc0.1    2.13-37
ii  libexpat1  2.1.0-1
ii  libsbuf6   9.0+ds1-3

libgeom1 recommends no packages.

libgeom1 suggests no packages.

-- no debconf information

[685625.debdiff (text/plain, attachment)]

Added tag(s) patch. Request was from Jeff Epler <jepler@unpythonic.net> to 685625-submit@bugs.debian.org. (Fri, 21 Dec 2012 19:39:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#685625; Package src:freebsd-utils. (Fri, 21 Dec 2012 22:06:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steven Chamberlain <steven@pyro.eu.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Fri, 21 Dec 2012 22:06:03 GMT) Full text and rfc822 format available.

Message #105 received at 685625@bugs.debian.org (full text, mbox):

From: Steven Chamberlain <steven@pyro.eu.org>
To: Jeff Epler <jepler@unpythonic.net>, 685625@bugs.debian.org
Cc: "debian-bsd@lists.debian.org" <debian-bsd@lists.debian.org>
Subject: Re: Bug#685625: implicit declaration of function ‘reallocf’
Date: Fri, 21 Dec 2012 22:02:45 +0000
Control: severity -1 grave
Control: affects -1 grub-common
Control: retitle -1 [kfreebsd] libgeom: may cause segfault of grub-probe

Hello,

On 21/12/12 18:45, Jeff Epler wrote:
> geom_getxml.c: In function ‘geom_getxml’:
> geom_getxml.c:59:2: warning: implicit declaration of function ‘reallocf’ [-Wimplicit-function-declaration]
> geom_getxml.c:59:2: warning: return makes pointer from integer without a cast [enabled by default]
> 
> On kfreebsd-amd64 systems, the consequence of this is that the top 32
> bits of a pointer returned by reallocf are discarded.

Curiously I have never been affected by this on kfreebsd-amd64.  My
kern.geom.confxml is only ~16 KiB.  The reporter could reproduce this
reliably with a kern.geom.confxml of ~4 MiB.

I observe some magic threshold of 136648 bytes, above which malloc() in
a simple C program starts to return an address with some of the high 32
bits set, triggering the bug.


I think the chance of this being a problem during install is very low,
unless there is some large pre-existing ZFS pool.

On an installed system, it would become impossible to update/upgrade
GRUB after exceeding some number of ZFS volumes * snapshots (I guess
around 500, but deleted snapshots still seem to count - that may also be
a bug).  Therefore I'm raising the severity of this.

It's not unreasonable to have 50 zvols (one per user/share on a NAS, for
example), and if taking weekly snapshots this could trigger after 10
weeks;  if daily, 10 days;  if hourly, 10 hours etc.


> -         -D__va_list=__builtin_va_list
> +         -D__va_list=__builtin_va_list \
> +	 -Werror=implicit-function-declaration

That's a good idea.


The buildd log scanner reveals a handful more cases of this compiler
warning in other GNU/kFreeBSD packages which we should probably look into:

https://buildd.debian.org/~brlink/bytag/E-pointer-trouble-at-implicit.html

* freebsd-buildutils
* freebsd-libs
* freebsd-utils

And I'm worried about some of the other packages mentioned, where the
error shows on kfreebsd-* or maybe hurd-*, but not on other arches.
Should they really all be doing this:

> ++#include <bsd/stdlib.h>

Or should we be trying to fix this elsewhere, in GNU/kFreeBSD headers maybe?

Thanks,
Regards,
-- 
Steven Chamberlain
steven@pyro.eu.org



Severity set to 'grave' from 'important' Request was from Steven Chamberlain <steven@pyro.eu.org> to 685625-submit@bugs.debian.org. (Fri, 21 Dec 2012 22:06:03 GMT) Full text and rfc822 format available.

Changed Bug title to '[kfreebsd] libgeom: may cause segfault of grub-probe' from 'libgeom: segfaults on large kern.geom.confxml' Request was from Steven Chamberlain <steven@pyro.eu.org> to 685625-submit@bugs.debian.org. (Fri, 21 Dec 2012 22:06:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#685625; Package src:freebsd-utils. (Fri, 21 Dec 2012 23:03:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jeff Epler <jepler@unpythonic.net>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Fri, 21 Dec 2012 23:03:03 GMT) Full text and rfc822 format available.

Message #114 received at 685625@bugs.debian.org (full text, mbox):

From: Jeff Epler <jepler@unpythonic.net>
To: Steven Chamberlain <steven@pyro.eu.org>
Cc: 685625@bugs.debian.org, "debian-bsd@lists.debian.org" <debian-bsd@lists.debian.org>
Subject: Re: Bug#685625: implicit declaration of function ‘reallocf’
Date: Fri, 21 Dec 2012 16:58:49 -0600
[snipped astute observations about the size of the xml data being important]

On Fri, Dec 21, 2012 at 10:02:45PM +0000, Steven Chamberlain wrote:
> And I'm worried about some of the other packages mentioned, where the
> error shows on kfreebsd-* or maybe hurd-*, but not on other arches.
> Should they really all be doing this:
> 
> > ++#include <bsd/stdlib.h>
> 
> Or should we be trying to fix this elsewhere, in GNU/kFreeBSD headers maybe?

I don't know the right fix.  I chose to #include <bsd/stdlib.h> because the
manpage (on debian-kFreeBSD) lists that as the proper header:

debian-kFreeBSD$ man reallocf
MALLOC(3)                BSD Library Functions Manual                MALLOC(3)

NAME
     reallocf — general purpose memory allocation functions

LIBRARY
     Utility functions from BSD systems (libbsd, -lbsd)

SYNOPSIS
     #include <bsd/stdlib.h>

     void *
     reallocf(void *ptr, size_t size);

I notice now that the guidance in the FreeBSD project's manpage is to simply
include <stdlib.h> for the declaration of reallocf:
    http://www.freebsd.org/cgi/man.cgi?query=reallocf

Unless you were going to put reallocf in eglibc I don't think you want it in
<stdlib.h>, since on debian-kFreeBSD use of reallocf will result in a link
error without -lbsd.

You can't simply make the bsd header be included via #include <stdlib.h>, as
-I/usr/include/bsd on the gcc commandline leads to a recursive inclusion error.

Jeff



Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#685625; Package src:freebsd-utils. (Fri, 21 Dec 2012 23:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steven Chamberlain <steven@pyro.eu.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Fri, 21 Dec 2012 23:51:03 GMT) Full text and rfc822 format available.

Message #119 received at 685625@bugs.debian.org (full text, mbox):

From: Steven Chamberlain <steven@pyro.eu.org>
To: Jeff Epler <jepler@unpythonic.net>
Cc: 685625@bugs.debian.org, "debian-bsd@lists.debian.org" <debian-bsd@lists.debian.org>, guillem@debian.org
Subject: Re: Bug#685625: implicit declaration of function ‘reallocf’
Date: Fri, 21 Dec 2012 23:47:47 +0000
Hi,

To further confuse things, here's a related problem in freebsd-buildutils:

> gcc -O2 -g -Wall -D_GNU_SOURCE -DMACHINE_ARCH='"i386"' -DMACHINE_MULTIARCH='"i386-kfreebsd-gnu"' -I/build/buildd-freebsd-buildutils_9.0-11-kfreebsd-i386-fRMINn/freebsd-buildutils-9.0/build-tree/src/sys -D_GNU_SOURCE=1 -isystem /usr/include/freebsd  -std=gnu99 -fstack-protector  -c excludes.c
> excludes.c: In function 'read_excludes_file':
> excludes.c:75:2: warning: implicit declaration of function 'fgetln' [-Wimplicit-function-declaration]
> excludes.c:75:15: warning: assignment makes pointer from integer without a cast [enabled by default]
> gcc -O2 -g -Wall -D_GNU_SOURCE -DMACHINE_ARCH='"i386"' -DMACHINE_MULTIARCH='"i386-kfreebsd-gnu"' -I/build/buildd-freebsd-buildutils_9.0-11-kfreebsd-i386-fRMINn/freebsd-buildutils-9.0/build-tree/src/sys -D_GNU_SOURCE=1 -isystem /usr/include/freebsd  -std=gnu99 -fstack-protector  -c misc.c
> gcc -O2 -g -Wall -D_GNU_SOURCE -DMACHINE_ARCH='"i386"' -DMACHINE_MULTIARCH='"i386-kfreebsd-gnu"' -I/build/buildd-freebsd-buildutils_9.0-11-kfreebsd-i386-fRMINn/freebsd-buildutils-9.0/build-tree/src/sys -D_GNU_SOURCE=1 -isystem /usr/include/freebsd  -std=gnu99 -fstack-protector  -c mtree.c
> gcc -O2 -g -Wall -D_GNU_SOURCE -DMACHINE_ARCH='"i386"' -DMACHINE_MULTIARCH='"i386-kfreebsd-gnu"' -I/build/buildd-freebsd-buildutils_9.0-11-kfreebsd-i386-fRMINn/freebsd-buildutils-9.0/build-tree/src/sys -D_GNU_SOURCE=1 -isystem /usr/include/freebsd  -std=gnu99 -fstack-protector  -c spec.c
> spec.c: In function 'set':
> spec.c:229:4: warning: implicit declaration of function 'setmode' [-Wimplicit-function-declaration]
> spec.c:229:11: warning: assignment makes pointer from integer without a cast [enabled by default]
> spec.c:232:4: warning: implicit declaration of function 'getmode' [-Wimplicit-function-declaration]

fgetln, setmode and getmode are defined in bsd/stdio.h and bsd/unistd.h.
 Using fgetln without its prototype truncates the pointer to 32 bits.
Fortunately a mode_t is only 16 bits long so getmode/setmode may be okay.

I think the preferred method is to use libbsd's 'overlay' in code that
needs these functions.  Previously freebsd-buildutils couldn't use the
overlay, so 20_libbsd_overlay.diff worked around it with extra includes:

http://anonscm.debian.org/viewvc/glibc-bsd/trunk/freebsd-buildutils/debian/patches/20_libbsd_overlay.diff?view=markup

Then for some unexplained reason that workaround got disabled;  the
overlay was never re-enabled though:

http://anonscm.debian.org/viewvc/glibc-bsd/trunk/freebsd-buildutils/debian/patches/series?r1=3805&r2=3960

[added Guillem Jover in Cc: in the hope he can explain any of this :) ]


Another occurrence is in freebsd-libs:

> cc -Wall -g -pipe -fPIC -I. -I/build/buildd-freebsd-libs_9.0+ds1-3-kfreebsd-i386-0LY6QJ/freebsd-libs-9.0+ds1/sys -D_GNU_SOURCE -D__va_list=__builtin_va_list -O2 -isystem /usr/include/freebsd -I/build/buildd-freebsd-libs_9.0+ds1-3-kfreebsd-i386-0LY6QJ/freebsd-libs-9.0+ds1/debian/local/include  -I/build/buildd-freebsd-libs_9.0+ds1-3-kfreebsd-i386-0LY6QJ/freebsd-libs-9.0+ds1/lib/libgeom -std=gnu99 -fstack-protector -Wsystem-headers -Wall -Wno-format-y2k -W -Wno-unused-parameter -Wstrict-prototypes -Wmissing-prototypes -Wpointer-arith -Wno-uninitialized -Wno-pointer-sign -c geom_ctl.c
> In file included from geom_ctl.c:38:0:
> /usr/include/freebsd/unistd.h: In function 'feature_present':
> /usr/include/freebsd/unistd.h:138:2: warning: implicit declaration of function 'strcmp' [-Wimplicit-function-declaration]
> geom_ctl.c: At top level:
> geom_ctl.c:55:1: warning: no previous prototype for 'gctl_dump' [-Wmissing-prototypes]
> geom_ctl.c: In function 'gctl_new_arg':
> geom_ctl.c:142:2: warning: implicit declaration of function 'reallocf' [-Wimplicit-function-declaration]
> geom_ctl.c:142:11: warning: assignment makes pointer from integer without a cast [enabled by default]

And many more places in freebsd-utils according to:

https://buildd.debian.org/~brlink/packages/f/freebsd-utils.html

Regards,
-- 
Steven Chamberlain
steven@pyro.eu.org



Added indication that bug 685625 blocks 696514 Request was from Steven Chamberlain <steven@pyro.eu.org> to submit@bugs.debian.org. (Sat, 22 Dec 2012 02:33:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#685625; Package src:freebsd-utils. (Sat, 22 Dec 2012 13:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Guillem Jover <guillem@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Sat, 22 Dec 2012 13:51:03 GMT) Full text and rfc822 format available.

Message #126 received at 685625@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: Steven Chamberlain <steven@pyro.eu.org>
Cc: Jeff Epler <jepler@unpythonic.net>, 685625@bugs.debian.org, debian-bsd@lists.debian.org, Robert Millan <rmh@debian.org>
Subject: Re: Bug#685625: implicit declaration of function ‘reallocf’
Date: Sat, 22 Dec 2012 14:49:33 +0100
On Fri, 2012-12-21 at 23:47:47 +0000, Steven Chamberlain wrote:
> To further confuse things, here's a related problem in freebsd-buildutils:
> 
> > gcc -O2 -g -Wall -D_GNU_SOURCE -DMACHINE_ARCH='"i386"' -DMACHINE_MULTIARCH='"i386-kfreebsd-gnu"' -I/build/buildd-freebsd-buildutils_9.0-11-kfreebsd-i386-fRMINn/freebsd-buildutils-9.0/build-tree/src/sys -D_GNU_SOURCE=1 -isystem /usr/include/freebsd  -std=gnu99 -fstack-protector  -c excludes.c
> > excludes.c: In function 'read_excludes_file':
> > excludes.c:75:2: warning: implicit declaration of function 'fgetln' [-Wimplicit-function-declaration]
> > excludes.c:75:15: warning: assignment makes pointer from integer without a cast [enabled by default]
> > gcc -O2 -g -Wall -D_GNU_SOURCE -DMACHINE_ARCH='"i386"' -DMACHINE_MULTIARCH='"i386-kfreebsd-gnu"' -I/build/buildd-freebsd-buildutils_9.0-11-kfreebsd-i386-fRMINn/freebsd-buildutils-9.0/build-tree/src/sys -D_GNU_SOURCE=1 -isystem /usr/include/freebsd  -std=gnu99 -fstack-protector  -c misc.c
> > gcc -O2 -g -Wall -D_GNU_SOURCE -DMACHINE_ARCH='"i386"' -DMACHINE_MULTIARCH='"i386-kfreebsd-gnu"' -I/build/buildd-freebsd-buildutils_9.0-11-kfreebsd-i386-fRMINn/freebsd-buildutils-9.0/build-tree/src/sys -D_GNU_SOURCE=1 -isystem /usr/include/freebsd  -std=gnu99 -fstack-protector  -c mtree.c
> > gcc -O2 -g -Wall -D_GNU_SOURCE -DMACHINE_ARCH='"i386"' -DMACHINE_MULTIARCH='"i386-kfreebsd-gnu"' -I/build/buildd-freebsd-buildutils_9.0-11-kfreebsd-i386-fRMINn/freebsd-buildutils-9.0/build-tree/src/sys -D_GNU_SOURCE=1 -isystem /usr/include/freebsd  -std=gnu99 -fstack-protector  -c spec.c
> > spec.c: In function 'set':
> > spec.c:229:4: warning: implicit declaration of function 'setmode' [-Wimplicit-function-declaration]
> > spec.c:229:11: warning: assignment makes pointer from integer without a cast [enabled by default]
> > spec.c:232:4: warning: implicit declaration of function 'getmode' [-Wimplicit-function-declaration]
> 
> fgetln, setmode and getmode are defined in bsd/stdio.h and bsd/unistd.h.
>  Using fgetln without its prototype truncates the pointer to 32 bits.
> Fortunately a mode_t is only 16 bits long so getmode/setmode may be okay.
> 
> I think the preferred method is to use libbsd's 'overlay' in code that
> needs these functions.  Previously freebsd-buildutils couldn't use the
> overlay, so 20_libbsd_overlay.diff worked around it with extra includes:
> 
> http://anonscm.debian.org/viewvc/glibc-bsd/trunk/freebsd-buildutils/debian/patches/20_libbsd_overlay.diff?view=markup

There were bugs in the libbsd include logic which made the overlay
unusable, this should be fixed now in latest libbsd versions. So it
should be possible to switch packages back, although I'm not sure of
the effects of mixing the libbsd overlay with the freebsd-glue stuff.
In any case I think that would be correct course of action, but then
I'm not sure either if that would be a minimal change solution, given
the freeze and all.

> Then for some unexplained reason that workaround got disabled;  the
> overlay was never re-enabled though:
> 
> http://anonscm.debian.org/viewvc/glibc-bsd/trunk/freebsd-buildutils/debian/patches/series?r1=3805&r2=3960
> 
> [added Guillem Jover in Cc: in the hope he can explain any of this :) ]

Thanks, I've added Robert to it too, as he is the one who did these
changes. My guess would be that he intended to reduce duplication and
maintenance costs by centralizing those fixes into a single package
(freebsd-glue).

> Another occurrence is in freebsd-libs:
> 
> > cc -Wall -g -pipe -fPIC -I. -I/build/buildd-freebsd-libs_9.0+ds1-3-kfreebsd-i386-0LY6QJ/freebsd-libs-9.0+ds1/sys -D_GNU_SOURCE -D__va_list=__builtin_va_list -O2 -isystem /usr/include/freebsd -I/build/buildd-freebsd-libs_9.0+ds1-3-kfreebsd-i386-0LY6QJ/freebsd-libs-9.0+ds1/debian/local/include  -I/build/buildd-freebsd-libs_9.0+ds1-3-kfreebsd-i386-0LY6QJ/freebsd-libs-9.0+ds1/lib/libgeom -std=gnu99 -fstack-protector -Wsystem-headers -Wall -Wno-format-y2k -W -Wno-unused-parameter -Wstrict-prototypes -Wmissing-prototypes -Wpointer-arith -Wno-uninitialized -Wno-pointer-sign -c geom_ctl.c
> > In file included from geom_ctl.c:38:0:
> > /usr/include/freebsd/unistd.h: In function 'feature_present':
> > /usr/include/freebsd/unistd.h:138:2: warning: implicit declaration of function 'strcmp' [-Wimplicit-function-declaration]
> > geom_ctl.c: At top level:
> > geom_ctl.c:55:1: warning: no previous prototype for 'gctl_dump' [-Wmissing-prototypes]
> > geom_ctl.c: In function 'gctl_new_arg':
> > geom_ctl.c:142:2: warning: implicit declaration of function 'reallocf' [-Wimplicit-function-declaration]
> > geom_ctl.c:142:11: warning: assignment makes pointer from integer without a cast [enabled by default]
> 
> And many more places in freebsd-utils according to:
> 
> https://buildd.debian.org/~brlink/packages/f/freebsd-utils.html

Thanks,
Guillem



Bug reassigned from package 'src:freebsd-utils' to 'libgeom1'. Request was from Steven Chamberlain <steven@pyro.eu.org> to control@bugs.debian.org. (Sun, 23 Dec 2012 22:54:03 GMT) Full text and rfc822 format available.

No longer marked as found in versions freebsd-utils/9.0+ds1-7. Request was from Steven Chamberlain <steven@pyro.eu.org> to control@bugs.debian.org. (Sun, 23 Dec 2012 22:54:03 GMT) Full text and rfc822 format available.

Marked as found in versions freebsd-libs/9.0+ds1-3. Request was from Steven Chamberlain <steven@pyro.eu.org> to control@bugs.debian.org. (Sun, 23 Dec 2012 22:54:04 GMT) Full text and rfc822 format available.

Marked as fixed in versions freebsd-libs/9.0+ds1-2. Request was from Steven Chamberlain <steven@pyro.eu.org> to control@bugs.debian.org. (Sun, 23 Dec 2012 23:06:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#685625; Package libgeom1. (Sat, 29 Dec 2012 04:30:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Christoph Egger <christoph@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Sat, 29 Dec 2012 04:30:03 GMT) Full text and rfc822 format available.

Message #139 received at 685625@bugs.debian.org (full text, mbox):

From: Christoph Egger <christoph@debian.org>
To: 685625@bugs.debian.org, debian-bsd@lists.debian.org
Cc: guillem@debian.org, rmh@debian.org
Subject: Re: libgeom: may cause segfault of grub-probe
Date: Fri, 28 Dec 2012 19:44:41 -0800
Hi!

  I see there's a patch in this bug report. Do you think this is a
solution for wheezy? If so I'd volunteer to upload a new version of
freebsd-libs

Regards

    Christoph




Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#685625; Package libgeom1. (Sat, 29 Dec 2012 15:45:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jeff Epler <jepler@unpythonic.net>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Sat, 29 Dec 2012 15:45:05 GMT) Full text and rfc822 format available.

Message #144 received at 685625@bugs.debian.org (full text, mbox):

From: Jeff Epler <jepler@unpythonic.net>
To: Christoph Egger <christoph@debian.org>, 685625@bugs.debian.org
Cc: debian-bsd@lists.debian.org, guillem@debian.org, rmh@debian.org
Subject: Re: Bug#685625: libgeom: may cause segfault of grub-probe
Date: Sat, 29 Dec 2012 09:43:28 -0600
If it's a question of minimal impact to fix the specific crash that
grub-probe encounters, then there are two more minimal ways to fix this
specific problem that come to mind:

replace reallocf with realloc---but in the unlikely case that realloc
fails, it doesn't deallocate the argument (this is the point of
reallocf)

explicitly declare reallocf instead of using the <bsd/> header:
    void *reallocf(void *, size_t)

however, I don't think either of these is better than the approach I
originally proposed, to add a #include directive that matches the one in
the reallocf manpage that debian ships.

(dropping the -Werror= flag addition would of course make it a bit more
minimal; it might avoid an FTBFS in the future, but if it's an FTBFS
that would point right at another crashing bug, well, it might be a
bonus rather than a detriment to FTBFS)

Being unfamiliar with the culture and practices of Debian, I can't speak
to whether a more invasive ('overlay') approach is appropriate or not in
light of the present freeze, but it seems that Guillem Jover has
concerns about doing that at this moment.

The machine where I originally encountered the trouble isn't yet in
production, so if there's an alternate fix proposed soon I'll be happy
to test it out.  On the other hand, I think the presence or absence of
the implicit declaration warning is enough to indicate whether the bug
is present under any given fix...

Jeff



Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#685625; Package libgeom1. (Sat, 29 Dec 2012 15:51:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Guillem Jover <guillem@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Sat, 29 Dec 2012 15:51:07 GMT) Full text and rfc822 format available.

Message #149 received at 685625@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: Christoph Egger <christoph@debian.org>
Cc: 685625@bugs.debian.org, debian-bsd@lists.debian.org, rmh@debian.org
Subject: Re: libgeom: may cause segfault of grub-probe
Date: Sat, 29 Dec 2012 16:49:11 +0100
On Fri, 2012-12-28 at 19:44:41 -0800, Christoph Egger wrote:
>   I see there's a patch in this bug report. Do you think this is a
> solution for wheezy? If so I'd volunteer to upload a new version of
> freebsd-libs

I've checked now the interaction of the libbsd-overlay and freebsd-glue,
and they do not play well. Consequently that would require way more
changes than the proposed patch, so even if I've not tested it, it would
seem to be the better solution for now given the freeze. Moving the
-Werror line one up would reduce the diff by 1, but that's pretty much
insignificant, so regardless of that:

Acked-by: Guillem Jover <guillem@debian.org>

I'll add missing stuff to libbsd, and for jessie I'll make freebsd-glue
play well with the overlay, once that's fixed the other packages can
be switched back to use the overlay.

Thanks,
Guillem



Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#685625; Package libgeom1. (Sat, 29 Dec 2012 16:51:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steven Chamberlain <steven@pyro.eu.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Sat, 29 Dec 2012 16:51:03 GMT) Full text and rfc822 format available.

Message #154 received at 685625@bugs.debian.org (full text, mbox):

From: Steven Chamberlain <steven@pyro.eu.org>
To: Christoph Egger <christoph@debian.org>, 685625@bugs.debian.org, debian-bsd@lists.debian.org, rmh@debian.org
Subject: Re: libgeom: may cause segfault of grub-probe
Date: Sat, 29 Dec 2012 16:47:17 +0000
Hi,

I agree that libbsd and freebsd-glue seem to conflict with each other,
but neither one of them by itself has everything needed for freebsd-libs.

So Jeff's patch is the least intrusive way to fix this, and that's what
we have to go with at this late stage.  It fixes a bug we're seeing now
and is unlikely to introduce more...

I can provide a similar patch for freebsd-utils which has the same
issues, but the only problem I could confirm yet was a segfault in
ifconfig bridge configuration (#696514) due to it.


I propose adding the -Werror part of the patch into Wheezy as well.  If
it does trigger a FTBFS, it's because we missed something, or something
wrong with the build environment that we need to know about.  We might
need to drop it someday for a new upstream release but hopefully not.

Regards,
-- 
Steven Chamberlain
steven@pyro.eu.org



Removed indication that bug 685625 blocks 696514 Request was from Steven Chamberlain <steven@pyro.eu.org> to 696514-submit@bugs.debian.org. (Sat, 29 Dec 2012 20:36:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#685625; Package libgeom1. (Sat, 29 Dec 2012 20:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steven Chamberlain <steven@pyro.eu.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Sat, 29 Dec 2012 20:39:03 GMT) Full text and rfc822 format available.

Message #161 received at 685625@bugs.debian.org (full text, mbox):

From: Steven Chamberlain <steven@pyro.eu.org>
To: Christoph Egger <christoph@debian.org>, 685625@bugs.debian.org, debian-bsd@lists.debian.org, rmh@debian.org
Subject: Re: libgeom: may cause segfault of grub-probe
Date: Sat, 29 Dec 2012 20:38:04 +0000
[Message part 1 (text/plain, inline)]
On 29/12/12 16:47, Steven Chamberlain wrote:
> I can provide a similar patch for freebsd-utils which has the same
> issues, but the only problem I could confirm yet was a segfault in
> ifconfig bridge configuration (#696514) due to it.

Attached is a similar patch for freebsd-utils, fixing implicit
declarations that are due to libbsd no longer being used.  Should we
apply it?

The warnings are potentially serious, but I don't know of any specific
bugs that this will fix.  (#696514 turned out not to be due to these).

Regards,
-- 
Steven Chamberlain
steven@pyro.eu.org
[implicit-declaration.patch (text/x-patch, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#685625; Package libgeom1. (Sat, 29 Dec 2012 22:03:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Christoph Egger <christoph@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Sat, 29 Dec 2012 22:03:05 GMT) Full text and rfc822 format available.

Message #166 received at 685625@bugs.debian.org (full text, mbox):

From: Christoph Egger <christoph@debian.org>
To: debian-release@lists.debian.org
Cc: 685625@bugs.debian.org, debian-bsd@lists.debian.org, rmh@debian.org, Steven Chamberlain <steven@pyro.eu.org>
Subject: Re: libgeom: may cause segfault of grub-probe
Date: Sat, 29 Dec 2012 13:59:41 -0800
Hi all!

  I'd like to hear -release@'s opinion on that. Do you prefer the
smaller patch only fixing the implicit declarations/includes where we
know it has caused this segfaults or can I upload the full change below?

Regards

    Christoph

Steven Chamberlain <steven@pyro.eu.org> writes:
> This is a multi-part message in MIME format.
> --------------030202080401090604090105
> Content-Type: text/plain; charset=ISO-8859-1
> Content-Transfer-Encoding: 7bit
>
> On 29/12/12 16:47, Steven Chamberlain wrote:
>> I can provide a similar patch for freebsd-utils which has the same
>> issues, but the only problem I could confirm yet was a segfault in
>> ifconfig bridge configuration (#696514) due to it.
>
> Attached is a similar patch for freebsd-utils, fixing implicit
> declarations that are due to libbsd no longer being used.  Should we
> apply it?
>
> The warnings are potentially serious, but I don't know of any specific
> bugs that this will fix.  (#696514 turned out not to be due to these).
>
> Regards,
> -- 
> Steven Chamberlain
> steven@pyro.eu.org
>
> --------------030202080401090604090105
> Content-Type: text/x-patch;
>  name="implicit-declaration.patch"
> Content-Transfer-Encoding: 7bit
> Content-Disposition: attachment;
>  filename="implicit-declaration.patch"
>
> Index: freebsd-utils-9.0+ds1/usr.sbin/mountd/mountd.c
> ===================================================================
> --- freebsd-utils-9.0+ds1.orig/usr.sbin/mountd/mountd.c	2012-12-29 19:56:58.000000000 +0000
> +++ freebsd-utils-9.0+ds1/usr.sbin/mountd/mountd.c	2012-12-29 20:05:01.478673213 +0000
> @@ -80,6 +80,8 @@
>  #include <stdlib.h>
>  #include <string.h>
>  #include <unistd.h>
> +#include <bsd/stdio.h>
> +
>  #include "pathnames.h"
>  #include "mntopts.h"
>  
> Index: freebsd-utils-9.0+ds1/usr.sbin/vidcontrol/vidcontrol.c
> ===================================================================
> --- freebsd-utils-9.0+ds1.orig/usr.sbin/vidcontrol/vidcontrol.c	2010-03-29 21:12:44.000000000 +0100
> +++ freebsd-utils-9.0+ds1/usr.sbin/vidcontrol/vidcontrol.c	2012-12-29 20:05:04.610607859 +0000
> @@ -48,6 +48,8 @@
>  #include <sys/errno.h>
>  #include <sys/types.h>
>  #include <sys/stat.h>
> +#include <bsd/err.h>
> +
>  #include "path.h"
>  #include "decode.h"
>  
> Index: freebsd-utils-9.0+ds1/usr.sbin/ppp/defs.c
> ===================================================================
> --- freebsd-utils-9.0+ds1.orig/usr.sbin/ppp/defs.c	2004-09-05 02:46:52.000000000 +0100
> +++ freebsd-utils-9.0+ds1/usr.sbin/ppp/defs.c	2012-12-29 20:00:01.091748618 +0000
> @@ -47,6 +47,7 @@
>  #include <time.h>
>  #endif
>  #include <unistd.h>
> +#include <bsd/unistd.h>
>  
>  #if defined(__FreeBSD__) && !defined(NOKLDLOAD)
>  #include "id.h"
> Index: freebsd-utils-9.0+ds1/usr.sbin/nfsd/nfsd.c
> ===================================================================
> --- freebsd-utils-9.0+ds1.orig/usr.sbin/nfsd/nfsd.c	2012-12-29 19:56:58.000000000 +0000
> +++ freebsd-utils-9.0+ds1/usr.sbin/nfsd/nfsd.c	2012-12-29 20:00:04.194641584 +0000
> @@ -71,6 +71,7 @@
>  #include <stdlib.h>
>  #include <string.h>
>  #include <unistd.h>
> +#include <bsd/unistd.h>
>  
>  /* Global defs */
>  #ifdef DEBUG
> Index: freebsd-utils-9.0+ds1/usr.sbin/arp/arp.c
> ===================================================================
> --- freebsd-utils-9.0+ds1.orig/usr.sbin/arp/arp.c	2012-12-29 19:56:58.000000000 +0000
> +++ freebsd-utils-9.0+ds1/usr.sbin/arp/arp.c	2012-12-29 20:00:07.442606898 +0000
> @@ -80,6 +80,7 @@
>  #include <string.h>
>  #include <strings.h>
>  #include <unistd.h>
> +#include <bsd/stdlib.h>
>  
>  typedef void (action_fn)(struct sockaddr_dl *sdl,
>  	struct sockaddr_inarp *s_in, struct rt_msghdr *rtm);
> Index: freebsd-utils-9.0+ds1/usr.sbin/rpc.lockd/kern.c
> ===================================================================
> --- freebsd-utils-9.0+ds1.orig/usr.sbin/rpc.lockd/kern.c	2012-12-29 19:56:58.000000000 +0000
> +++ freebsd-utils-9.0+ds1/usr.sbin/rpc.lockd/kern.c	2012-12-29 20:00:14.848822213 +0000
> @@ -52,6 +52,7 @@
>  #include <unistd.h>
>  #include <netdb.h>
>  #include <signal.h>
> +#include <bsd/unistd.h>
>  
>  #include <nlm_prot.h>
>  #include <nfs/nfsproto.h>
> Index: freebsd-utils-9.0+ds1/usr.sbin/pppctl/pppctl.c
> ===================================================================
> --- freebsd-utils-9.0+ds1.orig/usr.sbin/pppctl/pppctl.c	2004-12-13 14:50:13.000000000 +0000
> +++ freebsd-utils-9.0+ds1/usr.sbin/pppctl/pppctl.c	2012-12-29 20:00:17.754640690 +0000
> @@ -48,6 +48,7 @@
>  #include <string.h>
>  #include <time.h>
>  #include <unistd.h>
> +#include <bsd/unistd.h>
>  
>  #define LINELEN 2048
>  
> Index: freebsd-utils-9.0+ds1/usr.bin/kdump/kdump.c
> ===================================================================
> --- freebsd-utils-9.0+ds1.orig/usr.bin/kdump/kdump.c	2012-12-29 19:56:58.000000000 +0000
> +++ freebsd-utils-9.0+ds1/usr.bin/kdump/kdump.c	2012-12-29 20:05:19.540626059 +0000
> @@ -83,6 +83,8 @@
>  #include <time.h>
>  #include <unistd.h>
>  #include <vis.h>
> +#include <bsd/string.h>
> +
>  #include "ktrace.h"
>  #include "kdump_subr.h"
>  
> Index: freebsd-utils-9.0+ds1/sbin/geom/core/geom.c
> ===================================================================
> --- freebsd-utils-9.0+ds1.orig/sbin/geom/core/geom.c	2011-03-24 19:11:05.000000000 +0000
> +++ freebsd-utils-9.0+ds1/sbin/geom/core/geom.c	2012-12-29 20:06:16.428605677 +0000
> @@ -46,6 +46,8 @@
>  #include <inttypes.h>
>  #include <dlfcn.h>
>  #include <assert.h>
> +#include <bsd/err.h>
> +
>  #include <libgeom.h>
>  #include <geom.h>
>  
> Index: freebsd-utils-9.0+ds1/sbin/geom/class/eli/geom_eli.c
> ===================================================================
> --- freebsd-utils-9.0+ds1.orig/sbin/geom/class/eli/geom_eli.c	2010-11-22 20:10:48.000000000 +0000
> +++ freebsd-utils-9.0+ds1/sbin/geom/class/eli/geom_eli.c	2012-12-29 20:00:30.210625738 +0000
> @@ -43,6 +43,7 @@
>  #include <paths.h>
>  #include <errno.h>
>  #include <assert.h>
> +#include <bsd/stdlib.h>
>  
>  #include <sys/param.h>
>  #include <sys/mman.h>
> Index: freebsd-utils-9.0+ds1/sbin/geom/class/stripe/geom_stripe.c
> ===================================================================
> --- freebsd-utils-9.0+ds1.orig/sbin/geom/class/stripe/geom_stripe.c	2010-10-09 21:20:27.000000000 +0100
> +++ freebsd-utils-9.0+ds1/sbin/geom/class/stripe/geom_stripe.c	2012-12-29 20:02:33.016673155 +0000
> @@ -36,6 +36,8 @@
>  #include <string.h>
>  #include <strings.h>
>  #include <assert.h>
> +#include <bsd/stdlib.h>
> +
>  #include <libgeom.h>
>  #include <geom/stripe/g_stripe.h>
>  
> Index: freebsd-utils-9.0+ds1/sbin/geom/class/concat/geom_concat.c
> ===================================================================
> --- freebsd-utils-9.0+ds1.orig/sbin/geom/class/concat/geom_concat.c	2010-10-09 21:20:27.000000000 +0100
> +++ freebsd-utils-9.0+ds1/sbin/geom/class/concat/geom_concat.c	2012-12-29 20:02:36.477613023 +0000
> @@ -35,6 +35,8 @@
>  #include <string.h>
>  #include <strings.h>
>  #include <assert.h>
> +#include <bsd/stdlib.h>
> +
>  #include <libgeom.h>
>  #include <geom/concat/g_concat.h>
>  
> Index: freebsd-utils-9.0+ds1/sbin/geom/class/raid3/geom_raid3.c
> ===================================================================
> --- freebsd-utils-9.0+ds1.orig/sbin/geom/class/raid3/geom_raid3.c	2011-01-12 13:55:01.000000000 +0000
> +++ freebsd-utils-9.0+ds1/sbin/geom/class/raid3/geom_raid3.c	2012-12-29 20:02:42.593673584 +0000
> @@ -36,6 +36,8 @@
>  #include <string.h>
>  #include <strings.h>
>  #include <assert.h>
> +#include <bsd/stdlib.h>
> +
>  #include <libgeom.h>
>  #include <geom/raid3/g_raid3.h>
>  #include <core/geom.h>
> Index: freebsd-utils-9.0+ds1/sbin/geom/class/mirror/geom_mirror.c
> ===================================================================
> --- freebsd-utils-9.0+ds1.orig/sbin/geom/class/mirror/geom_mirror.c	2010-10-09 21:20:27.000000000 +0100
> +++ freebsd-utils-9.0+ds1/sbin/geom/class/mirror/geom_mirror.c	2012-12-29 20:02:47.384726078 +0000
> @@ -36,6 +36,8 @@
>  #include <string.h>
>  #include <strings.h>
>  #include <assert.h>
> +#include <bsd/stdlib.h>
> +
>  #include <libgeom.h>
>  #include <geom/mirror/g_mirror.h>
>  #include <core/geom.h>
> Index: freebsd-utils-9.0+ds1/sbin/geom/class/shsec/geom_shsec.c
> ===================================================================
> --- freebsd-utils-9.0+ds1.orig/sbin/geom/class/shsec/geom_shsec.c	2010-10-09 21:20:27.000000000 +0100
> +++ freebsd-utils-9.0+ds1/sbin/geom/class/shsec/geom_shsec.c	2012-12-29 20:02:51.019638336 +0000
> @@ -36,6 +36,8 @@
>  #include <string.h>
>  #include <strings.h>
>  #include <assert.h>
> +#include <bsd/stdlib.h>
> +
>  #include <libgeom.h>
>  #include <geom/shsec/g_shsec.h>
>  
> Index: freebsd-utils-9.0+ds1/sbin/swapon/swapon.c
> ===================================================================
> --- freebsd-utils-9.0+ds1.orig/sbin/swapon/swapon.c	2012-12-29 19:56:58.000000000 +0000
> +++ freebsd-utils-9.0+ds1/sbin/swapon/swapon.c	2012-12-29 20:03:04.126649982 +0000
> @@ -55,6 +55,8 @@
>  #include <string.h>
>  #include <unistd.h>
>  #include <fcntl.h>
> +#include <bsd/stdlib.h>
> +
>  #include <libutil.h>
>  
>  static void usage(void);
> Index: freebsd-utils-9.0+ds1/sbin/camcontrol/modeedit.c
> ===================================================================
> --- freebsd-utils-9.0+ds1.orig/sbin/camcontrol/modeedit.c	2010-06-11 18:02:57.000000000 +0100
> +++ freebsd-utils-9.0+ds1/sbin/camcontrol/modeedit.c	2012-12-29 20:01:06.245613425 +0000
> @@ -41,6 +41,7 @@
>  #include <stdio.h>
>  #include <sysexits.h>
>  #include <unistd.h>
> +#include <bsd/stdio.h>
>  
>  #include <cam/scsi/scsi_all.h>
>  #include <cam/cam.h>
> Index: freebsd-utils-9.0+ds1/sbin/devfs/rule.c
> ===================================================================
> --- freebsd-utils-9.0+ds1.orig/sbin/devfs/rule.c	2012-12-29 19:56:58.000000000 +0000
> +++ freebsd-utils-9.0+ds1/sbin/devfs/rule.c	2012-12-29 20:01:12.238673437 +0000
> @@ -44,6 +44,8 @@
>  #include <stdlib.h>
>  #include <string.h>
>  #include <unistd.h>
> +#include <bsd/stdlib.h>
> +#include <bsd/unistd.h>
>  
>  #include "extern.h"
>  
> Index: freebsd-utils-9.0+ds1/sbin/devfs/devfs.c
> ===================================================================
> --- freebsd-utils-9.0+ds1.orig/sbin/devfs/devfs.c	2012-12-29 19:56:58.000000000 +0000
> +++ freebsd-utils-9.0+ds1/sbin/devfs/devfs.c	2012-12-29 20:01:15.870628336 +0000
> @@ -43,6 +43,7 @@
>  #include <stdlib.h>
>  #include <string.h>
>  #include <unistd.h>
> +#include <bsd/stdio.h>
>  
>  #include "extern.h"
>  
> Index: freebsd-utils-9.0+ds1/sbin/ifconfig/af_inet.c
> ===================================================================
> --- freebsd-utils-9.0+ds1.orig/sbin/ifconfig/af_inet.c	2012-12-29 19:56:58.000000000 +0000
> +++ freebsd-utils-9.0+ds1/sbin/ifconfig/af_inet.c	2012-12-29 20:01:18.523614679 +0000
> @@ -43,6 +43,7 @@
>  #include <stdlib.h>
>  #include <string.h>
>  #include <unistd.h>
> +#include <bsd/stdlib.h>
>  
>  #include <netinet/in.h>
>  #include <net/if_var.h>		/* for struct ifaddr */
> Index: freebsd-utils-9.0+ds1/contrib/pf/authpf/authpf.c
> ===================================================================
> --- freebsd-utils-9.0+ds1.orig/contrib/pf/authpf/authpf.c	2012-12-29 19:56:58.000000000 +0000
> +++ freebsd-utils-9.0+ds1/contrib/pf/authpf/authpf.c	2012-12-29 20:03:24.975681073 +0000
> @@ -17,6 +17,8 @@
>   */
>  
>  #include <stdio.h>
> +#include <bsd/stdio.h>
> +
>  #include <sys/cdefs.h>
>  __FBSDID("$FreeBSD$");
>  
> Index: freebsd-utils-9.0+ds1/contrib/pf/pfctl/parse.y
> ===================================================================
> --- freebsd-utils-9.0+ds1.orig/contrib/pf/pfctl/parse.y	2012-12-29 19:56:58.000000000 +0000
> +++ freebsd-utils-9.0+ds1/contrib/pf/pfctl/parse.y	2012-12-29 20:01:42.634649462 +0000
> @@ -61,6 +61,7 @@
>  #include <pwd.h>
>  #include <grp.h>
>  #include <md5.h>
> +#include <bsd/stdlib.h>
>  
>  #include "pfctl_parser.h"
>  #include "pfctl.h"
> Index: freebsd-utils-9.0+ds1/contrib/pf/pfctl/pfctl.c
> ===================================================================
> --- freebsd-utils-9.0+ds1.orig/contrib/pf/pfctl/pfctl.c	2012-12-29 19:56:58.000000000 +0000
> +++ freebsd-utils-9.0+ds1/contrib/pf/pfctl/pfctl.c	2012-12-29 20:01:46.279635068 +0000
> @@ -60,6 +60,7 @@
>  #include <stdlib.h>
>  #include <string.h>
>  #include <unistd.h>
> +#include <bsd/stdlib.h>
>  
>  #include "pfctl_parser.h"
>  #include "pfctl.h"
> Index: freebsd-utils-9.0+ds1/contrib/pf/pfctl/pfctl_osfp.c
> ===================================================================
> --- freebsd-utils-9.0+ds1.orig/contrib/pf/pfctl/pfctl_osfp.c	2011-06-28 12:57:25.000000000 +0100
> +++ freebsd-utils-9.0+ds1/contrib/pf/pfctl/pfctl_osfp.c	2012-12-29 20:01:49.600683134 +0000
> @@ -33,6 +33,7 @@
>  #include <stdio.h>
>  #include <stdlib.h>
>  #include <string.h>
> +#include <bsd/stdio.h>
>  
>  #include "pfctl_parser.h"
>  #include "pfctl.h"
> Index: freebsd-utils-9.0+ds1/contrib/pf/pfctl/pfctl_table.c
> ===================================================================
> --- freebsd-utils-9.0+ds1.orig/contrib/pf/pfctl/pfctl_table.c	2011-06-28 12:57:25.000000000 +0100
> +++ freebsd-utils-9.0+ds1/contrib/pf/pfctl/pfctl_table.c	2012-12-29 20:01:52.597709013 +0000
> @@ -50,6 +50,7 @@
>  #include <stdlib.h>
>  #include <string.h>
>  #include <time.h>
> +#include <bsd/stdlib.h>
>  
>  #include "pfctl_parser.h"
>  #include "pfctl.h"
> Index: freebsd-utils-9.0+ds1/contrib/pf/pfctl/pfctl_optimize.c
> ===================================================================
> --- freebsd-utils-9.0+ds1.orig/contrib/pf/pfctl/pfctl_optimize.c	2012-12-29 19:56:58.000000000 +0000
> +++ freebsd-utils-9.0+ds1/contrib/pf/pfctl/pfctl_optimize.c	2012-12-29 20:01:55.921692089 +0000
> @@ -38,6 +38,7 @@
>  #include <stdio.h>
>  #include <stdlib.h>
>  #include <string.h>
> +#include <bsd/stdlib.h>
>  
>  #include "pfctl_parser.h"
>  #include "pfctl.h"
>
> --------------030202080401090604090105--

-- 



Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#685625; Package libgeom1. (Sun, 30 Dec 2012 00:03:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Christoph Egger <christoph@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Sun, 30 Dec 2012 00:03:05 GMT) Full text and rfc822 format available.

Message #171 received at 685625@bugs.debian.org (full text, mbox):

From: Christoph Egger <christoph@debian.org>
To: debian-release@lists.debian.org
Cc: 685625@bugs.debian.org, debian-bsd@lists.debian.org, rmh@debian.org, Steven Chamberlain <steven@pyro.eu.org>
Subject: Re: libgeom: may cause segfault of grub-probe
Date: Sat, 29 Dec 2012 15:56:53 -0800
Christoph Egger <christoph@debian.org> writes:
>   I'd like to hear -release@'s opinion on that. Do you prefer the
> smaller patch only fixing the implicit declarations/includes where we
> know it has caused this segfaults or can I upload the full change below?

Oh sorry I should read more carefull. That's of course a diff for a
different package (-utils vs -libs). I'm still inclined to also upload
-utils with that diff. Steven, SVN has fixes for #694374 and #695679
already. do you intent these for wheezy? If so let's add #696514 and
potentially the implicit declarations and get it uploaded as well.

Regards

    Christoph



Reply sent to Christoph Egger <christoph@debian.org>:
You have taken responsibility. (Sun, 30 Dec 2012 00:06:08 GMT) Full text and rfc822 format available.

Notification sent to Stig Sandbeck Mathisen <ssm@debian.org>:
Bug acknowledged by developer. (Sun, 30 Dec 2012 00:06:08 GMT) Full text and rfc822 format available.

Message #176 received at 685625-close@bugs.debian.org (full text, mbox):

From: Christoph Egger <christoph@debian.org>
To: 685625-close@bugs.debian.org
Subject: Bug#685625: fixed in freebsd-libs 9.0+ds1-4
Date: Sun, 30 Dec 2012 00:02:58 +0000
Source: freebsd-libs
Source-Version: 9.0+ds1-4

We believe that the bug you reported is fixed in the latest version of
freebsd-libs, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 685625@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Christoph Egger <christoph@debian.org> (supplier of updated freebsd-libs package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

Format: 1.8
Date: Sat, 29 Dec 2012 15:49:19 -0800
Source: freebsd-libs
Binary: libsbuf6 libsbuf6-udeb libsbuf-dev libcam6 libcam-dev libgeom1 libgeom-dev libgeom1-udeb libusbhid4debian libusbhid-common libusbhid-dev libusb2debian libusb2-dev libusb2debian-udeb libkvm0 libkvm-dev libdevstat7 libdevstat-dev libmemstat3 libmemstat-dev libnetgraph4 libnetgraph-dev libipx2 libipx-dev libipx2-udeb libkiconv4 libkiconv-dev libjail1 libjail-dev libalias7 libalias-dev
Architecture: source kfreebsd-amd64 all
Version: 9.0+ds1-4
Distribution: unstable
Urgency: low
Maintainer: GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>
Changed-By: Christoph Egger <christoph@debian.org>
Description: 
 libalias-dev - Development files for libalias
 libalias7  - FreeBSD packet aliasing library
 libcam-dev - Development files for libcam
 libcam6    - FreeBSD CAM (Common Access Method) library
 libdevstat-dev - Development files for libdevstat
 libdevstat7 - FreeBSD devstat (kernel interface) library
 libgeom-dev - Development files for libgeom
 libgeom1   - FreeBSD GEOM library
 libgeom1-udeb - FreeBSD GEOM library (udeb) (udeb)
 libipx-dev - Development files for libipx
 libipx2    - FreeBSD IPX address conversion support library
 libipx2-udeb - FreeBSD IPX address conversion support library (udeb) (udeb)
 libjail-dev - Development files for libjail
 libjail1   - FreeBSD jail library
 libkiconv-dev - Development files for libkiconv
 libkiconv4 - FreeBSD kernel side iconv library (udeb)
 libkvm-dev - Development files for libkvm
 libkvm0    - FreeBSD kvm (kernel memory interface) library
 libmemstat-dev - Development files for libmemstat
 libmemstat3 - FreeBSD memstat (kernel interface) library
 libnetgraph-dev - Development files for libnetgraph
 libnetgraph4 - FreeBSD netgraph (kernel interface) library
 libsbuf-dev - Development files for libsbuf
 libsbuf6   - FreeBSD string buffer library
 libsbuf6-udeb - FreeBSD string buffer library (udeb) (udeb)
 libusb2-dev - Development files for libusb2
 libusb2debian - FreeBSD userspace USB programming library
 libusb2debian-udeb - Development files for libusb2 (udeb) (udeb)
 libusbhid-common - Common files for the USB HID devices FreeBSD library
 libusbhid-dev - Development files for libusbhid
 libusbhid4debian - FreeBSD library to access USB HID devices
Closes: 685625
Changes: 
 freebsd-libs (9.0+ds1-4) unstable; urgency=low
 .
   [ Christoph Egger ]
   * Upload to unstable
 .
   [ Jeff Epler ]
   * Fix 'warning: implicit declaration of function 'reallocf'
     (and several other functions) (Closes: 685625)
   * Make that warning an error so that it does not pass silently
     in the future
Checksums-Sha1: 
 e8a4354a5d0d8eb2f8c5a55b742de9419ac126eb 3694 freebsd-libs_9.0+ds1-4.dsc
 cf14056890a2da795b4b376438c7ef94d0fc05b5 26320 freebsd-libs_9.0+ds1-4.debian.tar.gz
 b18ca7ead7828a62bde8278d5a6f332c75516e76 14466 libsbuf6_9.0+ds1-4_kfreebsd-amd64.deb
 a0ad4f425c4bae01f32e3e55470045d369819009 4502 libsbuf6-udeb_9.0+ds1-4_kfreebsd-amd64.udeb
 19be427339dcad8e83782c37c864e2f530331e24 13934 libsbuf-dev_9.0+ds1-4_kfreebsd-amd64.deb
 3af6e202bc1bfdac658bfbcabcbbd4363f76824f 61630 libcam6_9.0+ds1-4_kfreebsd-amd64.deb
 55d70ecda13c111edfac57c6621926e217beedf7 78730 libcam-dev_9.0+ds1-4_kfreebsd-amd64.deb
 95a312585fb45f4420dc124c5626e54d98256e49 20302 libgeom1_9.0+ds1-4_kfreebsd-amd64.deb
 8f4e09fde673b8b9b90b0695ebc3e2d681b0e89d 25364 libgeom-dev_9.0+ds1-4_kfreebsd-amd64.deb
 7ccebf08e720d3b8890aba7d8b2f8c889d2b3e6f 9196 libgeom1-udeb_9.0+ds1-4_kfreebsd-amd64.udeb
 5179e1069208f73e70d6861438e10dbc4c03835a 17342 libusbhid4debian_9.0+ds1-4_kfreebsd-amd64.deb
 e2333035d308b1bc8413601774a802b123809b44 21478 libusbhid-dev_9.0+ds1-4_kfreebsd-amd64.deb
 3bac46ff3458a5f12e04e11b500b56876e9deaf0 43350 libusb2debian_9.0+ds1-4_kfreebsd-amd64.deb
 4d136cd7b5105bd4def31bffd8b485ca7cd117c1 69650 libusb2-dev_9.0+ds1-4_kfreebsd-amd64.deb
 75d1417cb6f8b34a853f00b7a5d40e326122b4b3 27014 libusb2debian-udeb_9.0+ds1-4_kfreebsd-amd64.udeb
 65e497b33ae8635548094cf4bafdf92846d40c70 26572 libkvm0_9.0+ds1-4_kfreebsd-amd64.deb
 5a1c2a8311b74cba493294e09139aab5ac21aa41 50424 libkvm-dev_9.0+ds1-4_kfreebsd-amd64.deb
 b3ad4a206d1618b8e33a95224f3dcd70d7fe9c20 19916 libdevstat7_9.0+ds1-4_kfreebsd-amd64.deb
 e16a70570a0a07b6484829947877edfd746aea55 26496 libdevstat-dev_9.0+ds1-4_kfreebsd-amd64.deb
 b19e19e7f49d615dc1d9b5e4c3d4158a9620b96b 17912 libmemstat3_9.0+ds1-4_kfreebsd-amd64.deb
 880033c8f2ea36fd07a24d99dd9a9cb93994b748 24604 libmemstat-dev_9.0+ds1-4_kfreebsd-amd64.deb
 104b475eb70827c6981ec4341db756303bf654f2 18448 libnetgraph4_9.0+ds1-4_kfreebsd-amd64.deb
 2294eda8954a902421b4e09bdb5ae6381f08e920 22860 libnetgraph-dev_9.0+ds1-4_kfreebsd-amd64.deb
 69674045c244d8e9b0d3867086539de0f32ba03e 13520 libipx2_9.0+ds1-4_kfreebsd-amd64.deb
 c32363cd8ce4ea0238a3c02d4abc5cafc3ac83d3 15258 libipx-dev_9.0+ds1-4_kfreebsd-amd64.deb
 0de6493a843e16849240700dc7c9af71d4cf7c16 3814 libipx2-udeb_9.0+ds1-4_kfreebsd-amd64.udeb
 83d086e38dce2017f21c987a19674043b0789b3b 15878 libkiconv4_9.0+ds1-4_kfreebsd-amd64.deb
 4a0fc578909e0524d36682948d7b2e414ab04f2e 13132 libkiconv-dev_9.0+ds1-4_kfreebsd-amd64.deb
 ab88c56ebccb8d306dd21473e632c93da9a39088 20450 libjail1_9.0+ds1-4_kfreebsd-amd64.deb
 51b438289775f0cdd0f31e43ee64190cef4398b5 23332 libjail-dev_9.0+ds1-4_kfreebsd-amd64.deb
 d66b2921b9c6b2eb7581298d028302ddd81f73b7 32112 libalias7_9.0+ds1-4_kfreebsd-amd64.deb
 b3370ffc0cf7ac2081ec4311a443068f4bccd8ad 48940 libalias-dev_9.0+ds1-4_kfreebsd-amd64.deb
 b6ee4410111e16d62152d1cac143dabcf6cf63ff 24028 libusbhid-common_9.0+ds1-4_all.deb
Checksums-Sha256: 
 188024b8f2cd552b969a408527464cb585a4dddbd93589f6330dec3c080b48a4 3694 freebsd-libs_9.0+ds1-4.dsc
 1da320ccfc7dfa2b3656eb84018e14eb7bad89826579363983210e77737892f1 26320 freebsd-libs_9.0+ds1-4.debian.tar.gz
 22dd45ac790f61351ff584e65e940a6809a8aa829c700c6888e233ae22e7ea1d 14466 libsbuf6_9.0+ds1-4_kfreebsd-amd64.deb
 72df9d83fcdd4c0b5432f5e06c97312368adae30359b95bdd370fb22d47a668a 4502 libsbuf6-udeb_9.0+ds1-4_kfreebsd-amd64.udeb
 12ef4c813ee7c729eb2e2bad8ce0c29f6455bce76dff868dd143d7513c1cdccc 13934 libsbuf-dev_9.0+ds1-4_kfreebsd-amd64.deb
 eceae6bf5182fbd0241a5c09fd3696313324744ac2372cc7574dd9f6c85ce4ea 61630 libcam6_9.0+ds1-4_kfreebsd-amd64.deb
 fd72da41edee41f7c22d227ee7cd4a239011ed5d4130acb287ca0c73e2c59b2d 78730 libcam-dev_9.0+ds1-4_kfreebsd-amd64.deb
 b4379c943b9e1378097fd42f3c2d297db251ae42780978f331ef1cc4fd147f7e 20302 libgeom1_9.0+ds1-4_kfreebsd-amd64.deb
 b1b3d8d1cf1bd77859e9c17740ac06135242fad3db434631faa6d87682319aac 25364 libgeom-dev_9.0+ds1-4_kfreebsd-amd64.deb
 81f60fd684d1d3a96364765153a0657b446b808fd8c8d4106478da06456acce3 9196 libgeom1-udeb_9.0+ds1-4_kfreebsd-amd64.udeb
 031d70738bd088af08168f9bc5fc5d02de3c1fc619ac306ea31ae0f682017758 17342 libusbhid4debian_9.0+ds1-4_kfreebsd-amd64.deb
 ade7de32a29b57877f5c172d585c8e5c198c69bb26fd4ab07f2814d4dac274b7 21478 libusbhid-dev_9.0+ds1-4_kfreebsd-amd64.deb
 f62d31821a10677bd8ec8999d8cc09c98ec2b2e0071aef4c4a2f1d5aebf89ade 43350 libusb2debian_9.0+ds1-4_kfreebsd-amd64.deb
 6fd2d3dd6c9ea9a2cc748b96e0026bfda6e91b5e739d11bdffde3fe33eb3a244 69650 libusb2-dev_9.0+ds1-4_kfreebsd-amd64.deb
 2f1b6572ca87a3d36653942f9d923340dcf12863137e5670b16b57e14ee0d1b9 27014 libusb2debian-udeb_9.0+ds1-4_kfreebsd-amd64.udeb
 6a5a035ccfb5add9e6a46d159fef99a7557b69203e90f0826f56a2317fe76ca9 26572 libkvm0_9.0+ds1-4_kfreebsd-amd64.deb
 0a916f2a489e4a3d1e81a79e9bbb20e9a3fdb72653154ce61033cea8a44956e1 50424 libkvm-dev_9.0+ds1-4_kfreebsd-amd64.deb
 0631fd57aac5c05eb1552a4034ad2e43a80a65c19a175998e62f9576a12fc11a 19916 libdevstat7_9.0+ds1-4_kfreebsd-amd64.deb
 dfe8d3aa3ce08b128a6c3bf0be88ac862db59d377354625e49379ef67d156b92 26496 libdevstat-dev_9.0+ds1-4_kfreebsd-amd64.deb
 85a078d37fa1d291fb7b7e84b00f3cee36bcfe3ae2092e9da18ca25b9642cd8d 17912 libmemstat3_9.0+ds1-4_kfreebsd-amd64.deb
 eb02b17bc63229ad78f3868ad19c506ec7b32957698dd7a1d3588f26f67159c8 24604 libmemstat-dev_9.0+ds1-4_kfreebsd-amd64.deb
 ec8e634163c70027c5ba62424df0d812cd4c2afa48827d19eaf1b2702fbc691b 18448 libnetgraph4_9.0+ds1-4_kfreebsd-amd64.deb
 f1d284266cf11233f3a5e4296e979e4b1a894ba14012915e0f2c31eb251c1756 22860 libnetgraph-dev_9.0+ds1-4_kfreebsd-amd64.deb
 002471b99285de68883cd9a29f7e94b14558d98bce4a64df5bbf0598c9fcd28f 13520 libipx2_9.0+ds1-4_kfreebsd-amd64.deb
 9dbdb1077187812f630bf0d314eca58a842632227a3c76106eae27565544122b 15258 libipx-dev_9.0+ds1-4_kfreebsd-amd64.deb
 ed9f9270c175f974edd3e990dc0f5e6644e1a73ec5dfd766cfa5e343a6244919 3814 libipx2-udeb_9.0+ds1-4_kfreebsd-amd64.udeb
 ffc83f8bc093e304f7a98c0af2b5368d60409e7af3a4229d4b6eb8e3cdd4993e 15878 libkiconv4_9.0+ds1-4_kfreebsd-amd64.deb
 afd0295e01924967d75f94e46370c7c7248f3c2246240c943586ace86c3ddb4f 13132 libkiconv-dev_9.0+ds1-4_kfreebsd-amd64.deb
 0d17209c36aa86750447c161a0b4529c254f0c467db4c00ea90abc997f9c54c9 20450 libjail1_9.0+ds1-4_kfreebsd-amd64.deb
 c8007764d1ecf109b77523031b5a23c4e1e1d58866d5501d6b35d6962f43c9d0 23332 libjail-dev_9.0+ds1-4_kfreebsd-amd64.deb
 9c823fae1fabe46ff9992a84a95e21ac88d0347cd56983b8727688275cd388a2 32112 libalias7_9.0+ds1-4_kfreebsd-amd64.deb
 b61d5c64aeadc6a4157f546b9bd6c8594fc033239ebfd806427bbe07da4cd8b3 48940 libalias-dev_9.0+ds1-4_kfreebsd-amd64.deb
 eee04e428d08de1065307eeeaa3d9c4464ebdab37490d45b3ab246dc4c83bb4e 24028 libusbhid-common_9.0+ds1-4_all.deb
Files: 
 072c0965dc0df3cbf9de1e19a86b084a 3694 libs optional freebsd-libs_9.0+ds1-4.dsc
 0d9dd6cb5a92618b90b4148f5042936f 26320 libs optional freebsd-libs_9.0+ds1-4.debian.tar.gz
 ee64a31e4a433873a4c69ecc1a96885a 14466 libs optional libsbuf6_9.0+ds1-4_kfreebsd-amd64.deb
 599217eae561a0b63a14afa48558f830 4502 debian-installer optional libsbuf6-udeb_9.0+ds1-4_kfreebsd-amd64.udeb
 eacb8ab816f204a2912d13b18425c4c5 13934 libdevel optional libsbuf-dev_9.0+ds1-4_kfreebsd-amd64.deb
 b108e109854a8d09dcb669eaa7b2a527 61630 libs optional libcam6_9.0+ds1-4_kfreebsd-amd64.deb
 be117ce4cb6db1752c8c363e2dc9d977 78730 libdevel optional libcam-dev_9.0+ds1-4_kfreebsd-amd64.deb
 a02573b3df64a63f071bc56eda958803 20302 libs optional libgeom1_9.0+ds1-4_kfreebsd-amd64.deb
 ac6ab62193aebb48e5a989503a6b61dd 25364 libdevel optional libgeom-dev_9.0+ds1-4_kfreebsd-amd64.deb
 2f06549df5e3eb266f6dec8964ceb792 9196 debian-installer optional libgeom1-udeb_9.0+ds1-4_kfreebsd-amd64.udeb
 d5e645efd0a29ea39aeaa6a3fffc0e30 17342 libs optional libusbhid4debian_9.0+ds1-4_kfreebsd-amd64.deb
 246f3409d421867bab915acbf0f15a55 21478 libdevel optional libusbhid-dev_9.0+ds1-4_kfreebsd-amd64.deb
 4b6f54e7504b529a753051272860b626 43350 libs optional libusb2debian_9.0+ds1-4_kfreebsd-amd64.deb
 f760cce09748a509664a24751633867e 69650 libdevel optional libusb2-dev_9.0+ds1-4_kfreebsd-amd64.deb
 03c3a79cc3d45d4dab6a285e4bb5ceff 27014 debian-installer optional libusb2debian-udeb_9.0+ds1-4_kfreebsd-amd64.udeb
 4b87f991ca01f115516ade54b27ec3fd 26572 libs optional libkvm0_9.0+ds1-4_kfreebsd-amd64.deb
 5ade29697c4845c31b718e18aaf26c33 50424 libdevel optional libkvm-dev_9.0+ds1-4_kfreebsd-amd64.deb
 f4e385810d8dc6bb741880e2950789e7 19916 libs optional libdevstat7_9.0+ds1-4_kfreebsd-amd64.deb
 27cbefd163b805f8a5f62526427d84c2 26496 libdevel optional libdevstat-dev_9.0+ds1-4_kfreebsd-amd64.deb
 200163670a2cacf66b5b55b5834db1e3 17912 libs optional libmemstat3_9.0+ds1-4_kfreebsd-amd64.deb
 be8433263993052b190fa8713fe34cc3 24604 libdevel optional libmemstat-dev_9.0+ds1-4_kfreebsd-amd64.deb
 57dd48b37f8e53d2f45b9a85de9da765 18448 libs optional libnetgraph4_9.0+ds1-4_kfreebsd-amd64.deb
 908c2128708ca4ef21b896c203b5d101 22860 libdevel optional libnetgraph-dev_9.0+ds1-4_kfreebsd-amd64.deb
 b6960dd4a2a1afb3cdb7813d27039e06 13520 libs optional libipx2_9.0+ds1-4_kfreebsd-amd64.deb
 c0a3818e426e43f267041902cf18af9d 15258 libdevel optional libipx-dev_9.0+ds1-4_kfreebsd-amd64.deb
 8b4cebd03e84656ed30ea3b821ed5e9e 3814 debian-installer optional libipx2-udeb_9.0+ds1-4_kfreebsd-amd64.udeb
 c97a44637d79c97d94a92295958e6fb5 15878 libs optional libkiconv4_9.0+ds1-4_kfreebsd-amd64.deb
 bee50f6b4dfdf1a324868dff439a6ee4 13132 libdevel optional libkiconv-dev_9.0+ds1-4_kfreebsd-amd64.deb
 eae87fb080c012215c90e118b9a8c19e 20450 libs optional libjail1_9.0+ds1-4_kfreebsd-amd64.deb
 df9e5a44c0c253f1f511b62b04f6ecd4 23332 libdevel optional libjail-dev_9.0+ds1-4_kfreebsd-amd64.deb
 17e479994ad93cfcc29f6a54883d246d 32112 libs optional libalias7_9.0+ds1-4_kfreebsd-amd64.deb
 1164d4802f4b973af7db14e72be30d88 48940 libdevel optional libalias-dev_9.0+ds1-4_kfreebsd-amd64.deb
 c5c7c2cc2ccd3e01b8aa564a4f0175f9 24028 libs optional libusbhid-common_9.0+ds1-4_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/kFreeBSD)

iQIcBAEBCAAGBQJQ34IOAAoJEKv/7bJACMb5uwUQAK0Ne90j6MOo0Yzg/OlTBOIB
CPPypaM+1ynwPtUXKw5l5/bMJEvGM1lPopgGAbnu0vqAfScKPEddPd324qoeXn/q
Zmyg3adFFafMd0hY9q7zyjVmm+yS0awF3vOxnoRxDn9LoSUUSa7eJLTCfPxb0aHW
zXaYhyuIY+3d7IW7yXtabR6nRYhi6WXX2XPDTjZRc9ydwJ+CinaIhVAPP7gPV9Cn
d5DhVxrNS03YESLOicF/5M3CgaQbjNXOUuoVYyJLoHzLhoGVh1Gz2dCbEU+aFoLW
PbWU+2h8IhyCVX9c7ba72toDhZaaElADdBvMAyxJ/qJwdRqvB7DzMgunPAGmgZP0
fwC6tm0TuWoO4Uv0XrR/svtKOaJ0oS0WqPrZWK+yAKwsdqON85b7/Bq0BtuVRVZw
WuBlHKyl6K5DvIJPQUDUB8Ey4T/EmIAQfFCImmvzDNj7VcBROpmcryqBzyYt5T5z
SDJEbK17jC/JbOAwZMxfyzMIc3KSGrPssdHNu32X+l+uyq4HPRSaCU0cUxp6wKM0
4N2yZy1K8iC8wjsX5U2e3AO7YNyZ3N9DJUt48jN9w4a8S/iGpORvVgLzKXUyEcu6
o6HLStAMK5bQd9N1l0btZKuDMcracNyDwh5VXd0NT/oPEMDJjnod3PLcsZo8ebXa
rlIVO69yTcMnRnCBNUE2
=bWYt
-----END PGP SIGNATURE-----




Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#685625; Package libgeom1. (Sun, 30 Dec 2012 00:09:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steven Chamberlain <steven@pyro.eu.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Sun, 30 Dec 2012 00:09:06 GMT) Full text and rfc822 format available.

Message #181 received at 685625@bugs.debian.org (full text, mbox):

From: Steven Chamberlain <steven@pyro.eu.org>
To: Christoph Egger <christoph@debian.org>
Cc: debian-release@lists.debian.org, 685625@bugs.debian.org, debian-bsd@lists.debian.org, rmh@debian.org
Subject: Re: libgeom: may cause segfault of grub-probe
Date: Sun, 30 Dec 2012 00:05:45 +0000
On 29/12/12 23:56, Christoph Egger wrote:
> Steven, SVN has fixes for #694374 and #695679
> already. do you intent these for wheezy?

Yes, please.

They are not RC severity but sufficiently important for release, and in
particular #695679 should be fixed for people doing squeeze->wheezy
upgrades of jail systems.

> If so let's add #696514 and
> potentially the implicit declarations and get it uploaded as well.

I think it is beneficial, yes.  And as minimal as it can be.

There are some remaining implicit declarations, but are more complex,
therefore I'm leaving those as they are and I haven't enabled the
-Werror flag for this package yet.

Thanks!
Regards,
-- 
Steven Chamberlain
steven@pyro.eu.org



Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 06 Feb 2013 07:26:36 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 16:59:22 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.